angular.module('app.routes', [])

.config(['$stateProvider', '$urlRouterProvider', function($stateProvider, $urlRouterProvider) {

  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  .state('intro', {
    url: '/page1',
    templateUrl: 'templates/intro.html',
    controller: 'introCtrl',
    params:{
      hideSplash: false
    }
  })

  .state('signIn', {
    cache: false,
    url: '/page2',
    templateUrl: 'templates/signIn.html',
    controller: 'signInCtrl'
  })

  .state('menu', {
    url: '/side-menu21',
    templateUrl: 'templates/menu.html',
    abstract:true
  })

  .state('activation1', {
    url: '/page3',
    templateUrl: 'templates/activation1.html',
    controller: 'registrationCtrl'
  })

  .state('activation2', {
    url: '/page4',
    templateUrl: 'templates/activation2.html',
    controller: 'photoCtrl'
  })

  .state('activation3', {
    url: '/page5',
    templateUrl: 'templates/activation3.html',
    controller: 'activation3Ctrl'
  })

  .state('activation4', {
    url: '/page6',
    templateUrl: 'templates/activation4.html',
    controller: 'otpActivationCtrl'
  })

  .state('activation5', {
    cache: false,
    url: '/page7',
    templateUrl: 'templates/activation5.html',
    controller: 'signInCtrl',
    params:{
      showSuccessCard: false,
      successMessage: null,
      hideSplash: false
    }
  })

  .state('forgotMPIN', {
    cache: false,
    url: '/page24',
    templateUrl: 'templates/forgotMPIN.html',
    controller: 'forgotMPINCtrl'
  })

  .state('app', {
    url: '/app',
    abstract: true,
    templateUrl: 'templates/menu.html',
    controller: 'AppCtrl',
  })

  .state('app.home', {
    url: '/home',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/home.html',
        controller: 'homeCtrl'
      }
    }
  })

  .state('app.myAccountMain', {
    url: '/myAccPage',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/myAccountMain.html',
        controller: 'myAccountMainCtrl'
      }
    }
  })

  .state('app.balanceEnquiry', {
    url: '/page10',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/balanceEnquiry.html',
        controller: 'balanceEnquiryCtrl'
      }
    }
  })

  .state('app.miniStatement', {
    url: '/page13',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/miniStatement.html',
        controller: 'miniStatementCtrl'
      }
    }
  })

  .state('app.chequebookRequest', {
    url: '/page29',
    views: {
      'menuContent': {
        templateUrl: 'templates/chequebookRequest.html',
        controller: 'chequebookRequestCtrl'
      }
    }
  })

  .state('app.statementRequest', {
    url: '/page30',
    views: {
      'menuContent': {
        templateUrl: 'templates/statementRequest.html',
        controller: 'statementRequestCtrl'
      }
    }
  })

  .state('app.showLast5', {
    url: '/last5Txns',
    views: {
      'menuContent': {
        templateUrl: 'templates/last5Txns.html',
        controller: 'last5TxnsCtrl'
      }
    }
  })

  .state('app.showMMID', {
    url: '/mmidPage',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/showMMID.html',
        controller: 'showMMIDCtrl'
      }
    }
  })

  .state('app.fundsTransferMain', {
    url: '/page14',
    cache: true,
    params:{
      bene: null
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/fundsTransferMain.html',
        controller: 'fundsTransferMainCtrl'
      }
    }
  })

  .state('app.imps2mobile', {
    url: '/page15',
    cache: true,
    params:{
      bene: null
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/imps2mobile.html',
        controller: 'imps2mobileCtrl'
      }
    }
  })

  .state('app.imps2account', {
    url: '/page19',
    cache: true,
    params:{
      bene: null
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/imps2account.html',
        controller: 'imps2accountCtrl'
      }
    }
  })

  .state('app.neft2account', {
    url: '/page20',
    cache: true,
    params:{
      bene: null
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/neft2account.html',
        controller: 'neft2accountCtrl'
      }
    }
  })

  .state('app.otpForTransaction', {
    url: '/page22',
    cache: false,
    params:{
      txnType: null,
      txnMsgDesc: null,
      remeAccount: null,
      bene: null,
      amount: null,
      remarks: null 
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/otpForTransaction.html',
        controller: 'otpTransactionCtrl'
      }
    }
  })


  .state('app.fundsTransferSuccess', {
    url: '/page18/:bankTrnRRN',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/fundsTransferSuccess.html',
        controller: 'fundsTransferSuccessCtrl'
      }
    }
  })


  .state('app.beneficiaries', {
    url: '/page34',
    views: {
      'menuContent': {
        templateUrl: 'templates/beneficiaries.html',
        controller: 'beneficiariesCtrl'
      }
    }
  })

  .state('app.beneficiaryDetails', {
    url: '/page33',
    views: {
      'menuContent': {
        templateUrl: 'templates/beneficiaryDetails.html',
        controller: 'beneficiaryDetailsCtrl'
      }
    }
  })

  .state('app.changeMPIN', {
    url: '/page27',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/changeMPIN.html',
        controller: 'changeMPINCtrl'
      }
    }
  })

  .state('app.recharge', {
    url: '/rechargePage',
    cache: true,
    params:{
      recharge: true
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/recharge.html',
        controller: 'rechargeCtrl'
      }
    }
  })

  .state('app.billPay', {
    url: '/rechargePage',
    cache: true,
    params:{
      recharge: false
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/recharge.html',
        controller: 'rechargeCtrl'
      }
    }
  })
  
  .state('app.rechargeMpin', {
    url: '/rechargeMpinPage',
    cache: false,
    params:{
      rechargeInfo: null,
      recharge: true
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/rechargeMpin.html',
        controller: 'rechargeMpinCtrl'
      }
    }
  })

  .state('app.rechargeSuccess', {
    url: '/rechargeSuccessPage',
    cache: false,
    params: {
      response: null,
      merchantRefNo: null,
      bankRefNo: null,
      recharge: true
    },
    views: {
      'menuContent': {
        templateUrl: 'templates/rechargeSuccess.html',
        controller: 'rechargeSuccessCtrl'
      }
    }
  })

  .state('app.applyOnline', {
    url: '/page31',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/applyOnline.html',
        controller: 'applyOnlineCtrl'
      }
    }
  })

  .state('app.cardServices', {
    url: '/page35',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/cardServices.html',
        controller: 'cardServicesCtrl'
      }
    }
  })

  .state('app.newCardRequest', {
    url: '/page36',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/newCardRequest.html',
        controller: 'newCardRequestCtrl'
      }
    }
  })

  .state('app.cardUpgradeRequest', {
    url: '/page37',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/cardUpgradeRequest.html',
        controller: 'cardUpgradeRequestCtrl'
      }
    }
  })

  .state('app.cardBlockRequest', {
    url: '/page38',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/cardBlockRequest.html',
        controller: 'cardBlockRequestCtrl'
      }
    }
  })

  .state('app.contactUs', {
    url: '/page40',
    cache: true,
    views: {
      'menuContent': {
        templateUrl: 'templates/contactUs.html',
        controller: 'contactUsCtrl'
      }
    }
  })

  .state('app.branches', {
    url: '/page41',
    views: {
      'menuContent': {
        templateUrl: 'templates/branches.html',
        controller: 'branchesCtrl'
      }
    }
  })

  .state('app.atms', {
    url: '/atmPage',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/atms.html',
        controller: 'atmsCtrl'
      }
    }
  })

  .state('app.deregister', {
    url: '/page32',
    cache: false,
    views: {
      'menuContent': {
        templateUrl: 'templates/deregister.html',
        controller: 'deregisterCtrl'
      }
    }
  })  
// $urlRouterProvider.otherwise('/page3')
// $urlRouterProvider.otherwise('/app/home')
$urlRouterProvider.otherwise('/page7')

}]);
// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
var srvtApp = angular.module('app', ['ionic', 'app.config', 'app.routes', 'app.directives', 'app.constants', 'ngCordova', 'ngMessages', 'ui.validate', 'ngIdle', 'ionic.cloud'])
.config(['$httpProvider', 'IdleProvider', 'ServerConfig', '$ionicCloudProvider', function ($httpProvider, IdleProvider, ServerConfig, $ionicCloudProvider) {
      var noCacheInterceptor = ['$rootScope', '$q', 'ServerConfig', function ($rootScope, $q, ServerConfig) {
      return {
        'requestError': function (rejection) {
          $rootScope.hide();
          return $q.reject(rejection);
        },

        'response': function (response) {
          if ($rootScope.hide)
            $rootScope.hide();
          return response;
        },

        'responseError': function (rejection) {
          console.log (rejection);
          if ($rootScope.hide)
            $rootScope.hide();

          if(rejection.status <= 0) {
            $rootScope.showAlert("Error!", "Connection timed out!", function () {
            });
          } else {
            $rootScope.showAlert("Error!", 'Request to server failed.' + '\n' + rejection.statusText, function () {
            });
          }
          return $q.reject(rejection);
        },

        request: function (config) {
          /* Show Progress indicator for POST requests to Server */
          if (config.method == 'POST')
            $rootScope.show();
          config.timeout = ServerConfig.HTTP_TIMEOUT;
          return config;
        }
      };
    }];

    $ionicCloudProvider.init({
    "core": {
      "app_id": "e4acf043"
    }
  });

    $httpProvider.interceptors.push(noCacheInterceptor);
    /* FIXME: Remove headers for production/uat */
    // $httpProvider.defaults.headers.common = {};
    // $httpProvider.defaults.headers.post = {};
    // $httpProvider.defaults.headers.put = {};
    // $httpProvider.defaults.headers.patch = {};

    // IdleProvider.interrupt('mousemove keydown DOMMouseScroll mousewheel mousedown touchstart touchmove');
    IdleProvider.idle(ServerConfig.IDLE_TIMEOUT);
    IdleProvider.timeout(1);
    IdleProvider.autoResume(false);

  }])
.run(['$ionicPlatform', 'secureStorage', 'Auth', '$state', 'ConnectivityMonitor', '$ionicPopup', '$rootScope', 'srvtHelper','$cordovaDevice', '$ionicHistory', 'dbService', 'deviceInfo', '$q', 'Idle', 'appId', function($ionicPlatform, secureStorage, Auth, $state, ConnectivityMonitor, $ionicPopup, $rootScope, srvtHelper, $cordovaDevice, $ionicHistory, dbService, deviceInfo, $q, Idle, appId) {
  
   $rootScope.$on('$stateChangeStart', function(event, toState, toParams, fromState, fromParams){

      if (toState.name === "activation5")
        $ionicHistory.clearCache();
   });
   // Idle.watch();

   $rootScope.$on ('IdleInterrupt', function () {
      // console.log ('IdleInterrupt ++++++++++++++');
      Idle.watch();
   });

   // $rootScope.$on ('IdleWarn', function () {
   //    console.log ('IdleWarn ++++++++++++++');
   // });   
   console.log ('Config Values :');
   console.log (config);

   $rootScope.$on ('IdleTimeout', function (){
      console.log ('IdleTimeout ++++++++++++++');

            var confirm = $ionicPopup.confirm({
            title: 'Session Expired!',
            cssClass: 'srvt-popup',
              template: 'Your session has been idle for too long. You will need to login again.',
              buttons: [{ text: 'Login',
                      type: 'button-stable',
                    onTap: function (e) {
                      return false;
                    } },
                    { text: '<b>Exit<b>', 
                      type: 'button-dark',
                    onTap: function (e) {
                      return true;
                    }}]
            });
            confirm.then(function (res) {
              $rootScope.logout();
              if (res) {
                ionic.Platform.exitApp();
              }
            });
   });

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    // alert(1);
    srvtHelper.setRootScopeHooks($rootScope);

    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      // StatusBar.styleDefault();
      StatusBar.styleLightContent();

    }

    if (window.cordova && window.cordova.plugins && cordova.plugins.SecureStorage) {

      if (ionic.Platform.device().platform == "browser") {
        /* Using secureStorage for browser as sqlite plugin doesn't support browser platform */
        secureStorage.initialise()
        .then(function () {
          console.log ('secureStorage initialised!!');

          // if (ionic.Platform.device().platform != "browser")
          //   dbService.initDB();

          Auth.showFirstScreen();

        }, function (error) {
            console.log ('secureStorage could NOT be initialised!' + error);
        });
      } else {
        /* Use SQLite for device */
        dbService.initDB()
        .then (function () {
          Auth.showFirstScreen();
        }, function (err) {
          console.log ('Error initializing DB:' + err);
        })
      }
    }

    if (ConnectivityMonitor.isOffline()) {
      ConnectivityMonitor.showNoConnectionAlert();
    }

    deviceInfo.initialise()
    .then(function () {
      Auth.getAppToken(function (appToken) {
        console.log ('Fetched App Token:' + appToken);
      }, function () {
        console.log ('Failed to get App Token');
      });
    }, function () {
      console.log ('Failed to initialize device info!!');
    });
    
    // $q.all([
    //   deviceInfo.initialise(),
    //   deviceInfo.getMacId()]
    // ).then(function (values) {
    //   console.log('Received Values:');
    //   console.log(values[0]);
    //   console.log(values[1]);
    // }, function (error) {
    //   console.log('Error getting deviceInfo:');
    //   console.log (error);
    //   $rootScope.showAlert('Error!', error, function () {
    //     ionic.Platform.exitApp();
    //   });
    // })

    // deviceInfo.initialise()
    // .then(function () {

    // }, function (error) {
    //   $rootScope.showAlert('Error!', error, function () {
    //     ionic.Platform.exitApp();
    //   });
    // });

    ConnectivityMonitor.startWatching();

    // console.log ($cordovaDevice.getUUID());
    // console.log ($cordovaDevice.getPlatform());

  });
}]);
srvtApp.controller('AppCtrl', ['$scope', '$state', '$ionicSideMenuDelegate', '$timeout', '$rootScope', function($scope, $state, $ionicSideMenuDelegate, $timeout, $rootScope) {

      $rootScope.showMyAccountMenu = false;
      $rootScope.showFundsTransferMenu = false;
      $rootScope.showCardsMenu = false;
      $rootScope.showProfileMenu = false;

	$scope.showChangeMPIN = function () {
		$state.go('app.changeMPIN', {}, {reload: true});
	}

	$scope.showDeregisterScreen = function () {
		$state.go('app.deregister', {}, {reload: true});
	}

    $scope.hideAllSubmenus = function () {
      $rootScope.showMyAccountMenu = false;
      $rootScope.showFundsTransferMenu = false;
      $rootScope.showCardsMenu = false;
      $rootScope.showProfileMenu = false;
    }

	$scope.$watch(function () {
    		return $ionicSideMenuDelegate.isOpenLeft();
		},
	    function (isOpen) {

	    	if (isOpen == false) {
		      $timeout(function () {
		        $scope.hideAllSubmenus();
		      });
	      }

  	});
}])
srvtApp.service ('accountsModel', ['restAPIService', 'Auth', '$q', 'commonParameters', 'ServerConfig', 'logoutNotifier' ,function (restAPIService, Auth, $q, commonParameters, ServerConfig, logoutNotifier) {

  this.accounts= [];

  _accountsModel = this;

  logoutNotifier.subscribe (null, function () {
    console.log('Logout Notifier callback');
    _accountsModel.accounts = [];
  });

	this.getAccounts = function () {

      if (_accountsModel.accounts.length > 0)
        return _accountsModel.accounts;

		  var deferred = $q.defer();

		  var param = commonParameters.get();
          restAPIService.sendRequest(ServerConfig.GET_ACCOUNTS, param)
          .then(function(response) {
            console.log ('Received response for getAccounts');
            console.log (response);

            if (response.success == true) {
            	console.log('Accounts fetched!');
            	console.log(response);
              _accountsModel.accounts = response.data;
            	deferred.resolve(_accountsModel.accounts);
            } else {
            	deferred.reject(response);

            }
            return deferred.promise;

          }, 
          function (error) {
          	deferred.reject(error);
          	return deferred.promise;
          });

          return deferred.promise;
        }
}])
srvtApp.controller('applyOnlineCtrl', ['$scope', '$state', '$ionicNavBarDelegate', 'ServerConfig', 'restAPIService',function($scope, $state, $ionicNavBarDelegate, ServerConfig, restAPIService) {

    $ionicNavBarDelegate.showBackButton(true);

    $scope.options = [{title: 'Savings Account',
					   type: 'saving-account'},
					  {title: 'Current Account',
					   type: 'current-account'},
					  {title: 'Term Deposit',
					   type: 'term-deposit'},
					  {title: 'Recurring Deposit',
					   type: 'recurring-deposit'},
					  {title: 'Loan',
					   type: 'loan'},
					  {title: 'Life Insurance',
					   type: 'life-insurance'},
					  {title: 'General Insurance',
					   type: 'general-insurance'},
   					  {title: 'Investment',
					   type: 'investment'}];

	$scope.applyNow = function (selectedOption) {
    	var param = $scope.getCommonParams();
    	param['subject'] = selectedOption.type;

	    restAPIService.sendRequest(ServerConfig.APPLY_ONLINE, param)
	    .then(function(response) {
	      console.log ('Received response for applyNow');
	      console.log (response);

	      if (response.success == true) {
	       	console.log('Apply Now Successful!');
	       	console.log(response);
	       	$scope.showAlert("Request Sent", "Your request for " + selectedOption.title + " is sent to the bank.", function () {});
	      } else {
	       	console.log ('Apply Now Failed:');
	       	console.log (response);
	       	$scope.showAlert("Failed to Apply", response.response.mappErrorResponse, function (){
	       	});
	      }

	    },
	    function (error) {
	      console.log ('Failed to ApplyNow:' + error);
	    });
	}
}])
srvtApp.controller('atmsCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig', '$http', function($scope, $ionicNavBarDelegate, restAPIService, ServerConfig, $http) {

    $scope.states = [];
    $scope.cities = [];
    $scope.atms = [];
    $scope.data = {};
    $scope.data.query = "";
    $scope.noATMsFound = false;

    $http.get('regiondata/states.json')
    .then(function (response) {
    	console.log ('Data Read!');
    	console.log(response.data);
    	$scope.states = response.data;
    }, function (error) {
    	console.log('Received Error' + error);
    });

    $scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);
	});

    $scope.onStateChanged = function (selectedState) {

	    $http.get('regiondata/' + selectedState.split(' ').join('%20') + '.json')
	    .then(function (response) {
	    	console.log ('Data Read!');
	    	console.log(response.data);
	    	$scope.cities = response.data;
	    }, function (error) {
	    	console.log('Received Error' + error);
	    });
    }

    $scope.onCityChanged = function (selectedCity) {

		$scope.noATMsFound = false;
		$scope.data.query = "";

    	if (selectedCity != null && selectedCity.length > 0) {
			var param = $scope.getCommonParams();
			param['pincode'] = selectedCity;

			$scope.atms = [];
		    restAPIService.sendRequest(ServerConfig.ATM_LOCATOR, param)
		    .then(function(response) {
		      console.log ('Received response for getBranches');
		      console.log (response);

		      if (response.success == true) {
		       	$scope.atms = response.data;
		      } else {
		       	$scope.noATMsFound = true;
		      }

		    }, 
		    function (error) {
		      console.log ('Failed to get ATMs' + error);
		    });
	    }
    }

}])
srvtApp.service('Auth', ['secureStorage', '$state', 'dbService', 'logoutNotifier', '$ionicHistory', 'Idle', '$q', 'ServerConfig', 'deviceInfo', 'restAPIService',  function (secureStorage, $state, dbService, logoutNotifier, $ionicHistory, Idle, $q, ServerConfig, deviceInfo, restAPIService) {
	var loggedIn = false;
	var _auth = this;
	this.appToken = null;

	this.setLoggedIn = function (val) {
		loggedIn = val;

		if (val == false) {
			/* notify about logout event */
			logoutNotifier.notify();
		} else {
			/* Start watching for idle events on LogIn */
          	Idle.watch();
        }
	};

	this.isLoggedIn = function () {
		return loggedIn;
	};

	this.isRegistered = function () {
        if (ionic.Platform.device().platform == "browser")
			return secureStorage.get('app-secret');
		else 
			return dbService.getIsRegistered();
	};

	this.setIsRegistered = function (flag, mobileNo) {
		if (ionic.Platform.device().platform != "browser")
			return dbService.setIsRegistered(flag, mobileNo);
	}

	this.showFirstScreen = function () {
		  this.isRegistered()
          .then(function () {
	          	$ionicHistory.nextViewOptions({
				  disableBack: true,
				  historyRoot: true
				});
              /* User is registered; Go to SignIn screen */
              console.log ('----> Going to SignIn Screen');
              if ($state.is('activation5') == false)
              	$state.go('activation5', {hideSplash: true}, {reload: true});
              else
              	navigator.splashscreen.hide();
          }, function () {
	          	$ionicHistory.nextViewOptions({
				  disableBack: true,
				  historyRoot: true
				});
              /* User is not registered; Stay on intro screen */
              console.log ('----> Going to Intro Screen!');
              if ($state.is('intro') == false)
              	$state.go('intro', {hideSplash: true}, {reload: true});
          });
	};

	this.setAppToken = function (token) {
		this.appToken = token;
	}

	this.getAppToken = function () {
		  var deferred = $q.defer();

		  if (_auth.appToken != null) {
        	deferred.resolve(_auth.appToken);
        	return deferred.promise;
    	  }

	      var param = {
	        "bank": ServerConfig.BANK_ID,
	        "imei": deviceInfo.deviceId,
	        "imsi": deviceInfo.subscriberId,
	        "mac": deviceInfo.macId,
		  }

          dbService.getUserMobile()
          .then(function (mobileNo) {
          	  param["mobileNo"] = mobileNo;

	          restAPIService.sendRequest(ServerConfig.GET_APP_TOKEN, param)
	          .then(function(response) {
	            console.log ('Received response for getAppToken');
	            console.log (response);

	            if (response.success == true) {
	            	console.log('Accounts fetched!');
	            	console.log(response);
	              	_auth.appToken = response['app-token'];
	            	deferred.resolve(_auth.appToken);
	            } else {
	            	deferred.reject(response);

	            }
	            return deferred.promise;

	          }, 
	          function (error) {
	          	deferred.reject(error);
	          	return deferred.promise;
	          });

          },
          function (error) {
          	console.log ('Auth::Failed to get User Mobile!!');
	          	deferred.reject(error);
	          	return deferred.promise;
          });

      return deferred.promise;

	}
}])
srvtApp.controller('balanceEnquiryCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig', function($scope, $ionicNavBarDelegate, restAPIService, ServerConfig) {
	$ionicNavBarDelegate.showBackButton(true);
	// $scope.selectedAccount = null;
	$scope.data = {};
	$scope.data.selectedAccount = null;

	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if ($scope.accounts.length == 0)
			$scope.getAccounts();

		// $scope.selectedAccount = $scope.accounts[0];
	});

	$scope.$on("$ionicView.afterEnter", function () {

		if ($scope.data.selectedAccount != null) {
			$scope.onAccountChanged($scope.data.selectedAccount);
		}
	})

	$scope.onAccountChanged = function (selectedAccount) {
  	// fetch balance for selected account
		$scope.balance = null;
		$scope.bankRRN = null;

  		if (selectedAccount != null) {
	  	  // var param = commonParameters.get();
  	  	  var param = $scope.getCommonParams();

	  	  param['account-number'] = selectedAccount.accountNo;
		  param['mobileNo'] = selectedAccount.mobileNo;

	      restAPIService.sendRequest(ServerConfig.BALANCE_ENQUIRY, param)
	      .then(function(response) {
	        console.log ('Received response for BALANCE_ENQUIRY');
	        console.log (response);

	        if (response.success == true) {
	        	console.log();
	        	$scope.balance = response.response['AvailableBalance'];
	        	$scope.bankRRN = response.response['bankRRN'];
	        } else {

	        	$scope.showAlert("Failed to get Balance!", response.response['mappErrorResponse'], function (res) {
	        	});

	        }
	      });
    	}  
    }
}])
srvtApp.controller('beneficiariesCtrl', ['$scope', '$ionicNavBarDelegate', 'beneficiaryModel', '$q', function($scope, $ionicNavBarDelegate, beneficiaryModel, $q) {

  $scope.$on("$ionicView.beforeEnter", function() {
    /* Added here so that back button is visible even if the view is loaded from cache */
    $ionicNavBarDelegate.showBackButton(true);

    $scope.beneficiaryModel = beneficiaryModel;

    if (beneficiaryModel.list == null)
      getBeneficiaries();

  });

  function getBeneficiaries () {
    $q.when(beneficiaryModel.getList())
    .then(function (list) {
    }, function (){

    });
  }

  $scope.deleteClicked = function (bene) {
    $scope.showConfirmationAlert ('Delete Beneficiary?', 'Delete ' + bene.nick + ' from the list ?', 'Delete', 
      function (response) {
        if (response === true) {
          console.log('Delete Confirmed!');
          beneficiaryModel.deleteBeneficiary(bene)
          .then(function (response) {
            $scope.showAlert ('Beneficiary Deleted', 'Beneficiary deleted successfully!.', function () {});
          }, function (error) {
            $scope.showAlert ('Failed to Delete Beneficiary!', 'Please try again later.', function () {});
          })
        }
      }
    );
  }
}])
srvtApp.controller('beneficiaryDetailsCtrl', ['$scope', '$ionicHistory', 'beneficiaryModel', function($scope, $ionicHistory, beneficiaryModel) {

	$scope.data = {
		nick: "",
		accountName: "",
		account: "",
		ifsc: "",
		mobile: "",
		mmid: ""
	};

	$scope.$on("$ionicView.afterEnter", function() {
		$scope.focusOn('focusMe');
	});

	$scope.submit = function (form) {
		if (form.$invalid)
			return;

    	$scope.hideKeyboard();

		beneficiaryModel.addBeneficiary($scope.data)
		.then(function () {
			console.log ('Beneficiary Added successfully!');
	       	$scope.showAlert("Success !", "Beneficiary Added successfully", function () {
	       		$ionicHistory.goBack();
	       	});

		}, function (error) {
			console.log ('Beneficiary Add Failed!' + error);
			console.log(error);
	       	$scope.showAlert("Beneficiary addition failed!", response.response.mappErrorResponse, function () {});

		});
	}

	$scope.cancel = function () {
		$ionicHistory.goBack();
	}

	$scope.validate = function () {
		// Check if atleast one of account name or Mobile no is entered
		if ((typeof $scope.data.accountName !== "undefined") && $scope.data.accountName.length == 0 && (typeof $scope.data.mobile) !== "undefined" && $scope.data.mobile.length == 0)
			return false;
		return true;
	}
}])
srvtApp.service ('beneficiaryModel', ['restAPIService', '$q', 'commonParameters', 'ServerConfig', 'logoutNotifier' ,function (restAPIService, $q, commonParameters, ServerConfig, logoutNotifier) {

  this.list = null;

  _beneficiaryModel = this;

  logoutNotifier.subscribe (null, function () {
    console.log('Logout Notifier callback');
    _beneficiaryModel.list = null;
  });

  this.getList = function () {
      if (this.list != null)
        return this.list;

      var deferred = $q.defer();

      var param = commonParameters.get();

      restAPIService.sendRequest(ServerConfig.GET_BENEFICIARY_LIST, param)
      .then(function(response) {
        console.log ('Received response for getAccounts');
        console.log (response);

        if (response.success == true) {
          console.log('List fetched!');
          console.log(response);
          _beneficiaryModel.list = response.data;
          deferred.resolve(_beneficiaryModel.list);
        } else {
          deferred.reject(response);

        }
        return deferred.promise;

      }, 
      function (error) {
        deferred.reject(error);
        return deferred.promise;
      });

      return deferred.promise;
  }

	this.addBeneficiary = function (bene) {

		  var deferred = $q.defer();

		  var param = commonParameters.get();

      param['bene-nick-name'] = bene.nick;
      if (bene.mmid.length > 0) {
        param['bene-mmid'] = bene.mmid;
        param['bene-mobile'] = bene.mobile;
      } else {
        /* Remove the blank properties from bene object, as they are used to filter beneficiaries list */
        delete bene.mmid;
        delete bene.mobile;
      }

      if (bene.accountName.length > 0) {
        param['bene-account'] = bene.account;
        param['account-name'] = bene.accountName;
        param['bene-ifsc'] = bene.ifsc;
      } else {
        /* Remove the blank properties from bene object, as they are used to filter beneficiaries list */
        delete bene.account;
        delete bene.accountName;
        delete bene.ifsc;
      }

      restAPIService.sendRequest(ServerConfig.ADD_BENEFICIARY, param)
      .then(function(response) {
        console.log ('Received response for add Beneficiary');
        console.log (response);

        if (response.success == true) {
        	console.log(response);
          bene['id'] = response.response['payee-id'];
          if (_beneficiaryModel.list === null) {
            _beneficiaryModel.list = [];
          }
          _beneficiaryModel.list.push(bene);
        	deferred.resolve();
        } else {
        	deferred.reject(response);
        }
        return deferred.promise;

      }, 
      function (error) {
      	deferred.reject(error);
      	return deferred.promise;
      });

      return deferred.promise;
     }


     this.deleteBeneficiary = function (bene) {

      var deferred = $q.defer();

      var param = commonParameters.get();

      param['payee-id'] = bene.id;

      restAPIService.sendRequest(ServerConfig.DELETE_BENEFICIARY, param)
      .then(function(response) {
        console.log ('Received response for add Beneficiary');
        console.log (response);

        if (response.success == true) {
          console.log(response);
          var i = _beneficiaryModel.list.indexOf(bene);
          if (i != -1)
            _beneficiaryModel.list.splice(i,1);
          deferred.resolve();
        } else {
          deferred.reject(response);
        }
        return deferred.promise;

      }, 
      function (error) {
        deferred.reject(error);
        return deferred.promise;
      });

      return deferred.promise;

     }

}])
srvtApp.controller('branchesCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig', '$http', '$ionicConfig', function($scope, $ionicNavBarDelegate, restAPIService, ServerConfig, $http, $ionicConfig) {
    $ionicNavBarDelegate.showBackButton(true);

    $scope.states = [];
    $scope.cities = [];
    $scope.branches = [];
    $scope.data = {};
    $scope.data.query = "";
    $scope.noBranchesFound = false;

    $http.get('regiondata/states.json')
    .then(function (response) {
    	console.log ('Data Read!');
    	console.log(response.data);
    	$scope.states = response.data;
    }, function (error) {
    	console.log('Received Error' + error);
    });

    $scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if (ionic.Platform.device().platform === "iOS") {
			/* Setting back button text to Back on iOS as it shows ellipsis on iphone 5/4 for large title */
			$ionicConfig.backButton.previousTitleText(false);

			$ionicConfig.backButton.text('Back');
		}
	});

    $scope.$on("$ionicView.beforeLeave", function() {

		if (ionic.Platform.device().platform === "iOS") {
			$ionicConfig.backButton.previousTitleText(true);
		}

	});
    $scope.onStateChanged = function (selectedState) {

	    $http.get('regiondata/' + selectedState.split(' ').join('%20') + '.json')
	    .then(function (response) {
	    	console.log ('Data Read!');
	    	console.log(response.data);
	    	$scope.cities = response.data;
	    }, function (error) {
	    	console.log('Received Error' + error);
	    });
    }

    $scope.onCityChanged = function (selectedCity) {

		$scope.noBranchesFound = false;
		$scope.data.query = "";

    	if (selectedCity != null && selectedCity.length > 0) {
			var param = $scope.getCommonParams();
			param['pincode'] = selectedCity;

			$scope.branches = [];
		    restAPIService.sendRequest(ServerConfig.BRANCH_LOCATOR, param)
		    .then(function(response) {
		      console.log ('Received response for getBranches');
		      console.log (response);

		      if (response.success == true) {
		       	$scope.branches = response.data;
		      } else {
		       	$scope.noBranchesFound = true;
		      }

		    }, 
		    function (error) {
		      console.log ('Failed to Branches:' + error);
		    });
	    }
    }

}])
.controller('cardBlockRequestCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig', function ($scope, $ionicNavBarDelegate, restAPIService, ServerConfig) {

	$scope.data = {};

	$scope.$on("$ionicView.beforeEnter", function() {
		/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

	    if ($scope.accounts.length == 0)
	      $scope.getAccounts();

	});

	$scope.submit = function (form) {

		if (form.$invalid)
			return;

    	var param = $scope.getCommonParams();

    	param['account-number'] = $scope.data.selectedAccount.accountNo;

	    restAPIService.sendRequest(ServerConfig.BLOCK_CARD, param)
	    .then(function(response) {
	      console.log ('Received response for applyNow');
	      console.log (response);

	      if (response.success == true) {
	       	console.log(response);
	       	$scope.showAlert("Request Sent", "Your request for Blocking the card is sent to the bank.", function () {
	       		$scope.showHome();
	       	});
	      } else {
	       	console.log (response);
	       	$scope.showAlert("Failed to Apply", response.response.mappErrorResponse, function (){
	       	});
	      }

	    },
	    function (error) {
	      console.log ('Failed to ApplyNow:' + error);
	    });
	}

}])
.controller('cardServicesCtrl', ['$scope', '$ionicNavBarDelegate', function ($scope, $ionicNavBarDelegate) {

  $scope.$on("$ionicView.beforeEnter", function() {
    /* Added here so that back button is visible even if the view is loaded from cache */
    $ionicNavBarDelegate.showBackButton(true);

  });

}])
.controller('cardUpgradeRequestCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig',function ($scope, $ionicNavBarDelegate, restAPIService, ServerConfig) {

	$scope.data = {};
	$scope.data.cards = [{ name: "Rupay Debit Card", type: "RupayDebitCard"},
						 { name: "Rupay Gold Card", type: "RupayGoldCard"},
						 { name: "Rupay Platinum Card", type: "RupayPlatinumCard"},
						 { name: "Rupay Kissan Card (KCC)", type:"RupayKissanCard"}];

	$scope.data.selectedCardType = $scope.data.cards[0].type;

	$scope.$on("$ionicView.beforeEnter", function() {
		/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

	    if ($scope.accounts.length == 0)
	      $scope.getAccounts();

	});

	$scope.submit = function (form) {

		if (form.$invalid)
			return;

    	var param = $scope.getCommonParams();

    	param['subject'] = 'card-upgrade';
    	param['card-type'] = $scope.data.selectedCardType
    	param['account-number'] = $scope.data.selectedAccount.accountNo;

	    restAPIService.sendRequest(ServerConfig.APPLY_ONLINE, param)
	    .then(function(response) {
	      console.log ('Received response for applyNow');
	      console.log (response);

	      if (response.success == true) {
	       	console.log('Apply Now Successful!');
	       	console.log(response);
	       	$scope.showAlert("Request Sent", "Your request for Card Upgrade is sent to the bank.", function () {
	       		$scope.showHome();
	       	});
	      } else {
	       	console.log ('Apply Now Failed:');
	       	console.log (response);
	       	$scope.showAlert("Failed to Apply", response.response.mappErrorResponse, function (){
	       	});
	      }

	    },
	    function (error) {
	      console.log ('Failed to ApplyNow:' + error);
	    });
	}

}])
srvtApp.controller('changeMPINCtrl', ['$scope', '$ionicNavBarDelegate','$state','restAPIService', 'ServerConfig', function($scope, $ionicNavBarDelegate, $state, restAPIService, ServerConfig) {
	$scope.data = {};
	$scope.mpinMismatch = false;

  $scope.$on("$ionicView.beforeEnter", function() {
    /* Added here so that back button is visible even if the view is loaded from cache */
    $ionicNavBarDelegate.showBackButton(true);
  });

	$scope.submit = function (form) {

      if ($scope.data.newMpin != $scope.data.newMpin2) {
        $scope.mpinMismatch = true;
        return;
      }

      if (form.$invalid)
        return;

      $scope.hideKeyboard();

      var param = $scope.getCommonParams();

      param['pin'] = md5($scope.data.oldMpin);
      param['new-pin'] = md5($scope.data.newMpin);

      restAPIService.sendRequest(ServerConfig.CHANGE_PIN, param)
      .then(function(response) {
        console.log ('Received response for CHANGE_PIN');
        console.log (response);

        if (response.success == true) {
      		$state.go('activation5', {showSuccessCard: true, successMessage:"MPIN reset successful"});
        } else {
          $scope.showAlert('Failed!', response.response["mappErrorResponse"], function(){});
        }
      });

	}

}])
srvtApp.controller('chequebookRequestCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig', '$ionicHistory', function($scope, $ionicNavBarDelegate, restAPIService, ServerConfig, $ionicHistory) {

  $scope.data = {};

  $scope.$on("$ionicView.beforeEnter", function() {
  /* Added here so that back button is visible even if the view is loaded from cache */
    $ionicNavBarDelegate.showBackButton(true);

    if ($scope.accounts.length == 0)
      $scope.getAccounts();
  });

  $scope.submit = function (form) {

    if (form.$invalid)
      return;

    var param = $scope.getCommonParams();

    param['account-number'] = $scope.data.selectedAccount.accountNo;

    restAPIService.sendRequest(ServerConfig.CHEQUE_BOOK_REQUEST, param)
    .then(function(response) {
      console.log ('Received response for CHEQUE_BOOK_REQUEST');
      console.log (response);

      if (response.success == true) {
       	$scope.showAlert("Request Sent", "Your request for new Cheque book is sent to the bank.", function () {
            $ionicHistory.goBack();
        });
      } else {
       	$scope.showAlert("Failed to Apply", response.response.mappErrorResponse, function (){
       	});
      }

    },
    function (error) {
      console.log ('Failed to ApplyNow:' + error);
    });

  }
}])
srvtApp.service ('commonParameters', [function () {

	commonParams = {};
	this.get = function () {
		return angular.copy(commonParams);
	}

	this.set = function (obj) {
		commonParams = obj;
	}
}])
srvtApp.service('ConnectivityMonitor', ['$rootScope', '$cordovaNetwork', '$ionicPopup', 'Auth', function($rootScope, $cordovaNetwork, $ionicPopup, Auth) {
 
    this.isOnline = function(){
      // if(ionic.Platform.isWebView()){
      if(ionic.Platform.device().platform != "browser"){
        return $cordovaNetwork.isOnline();    
      } else {
        return navigator.onLine;
      }
    };
    
    this.isOffline = function(){
      // if(ionic.Platform.isWebView(){
      if(ionic.Platform.device().platform != "browser"){
        return !$cordovaNetwork.isOnline();
      } else {
        return !navigator.onLine;
      }
    };

    this.showNoConnectionAlert = function () {
    	var popupShown = false;
        if (popupShown == false) {
        	popupShown = true;
            var alert = $ionicPopup.alert({
        		title: 'No Network Connection!',
            	template: 'Please check the phone network settings and try again.'
            });
            alert.then(function(res) {
            	popupShown = false;
            	Auth.showFirstScreen();
            });
   		}
    };

    this.startWatching = function() {
    	var cm = this;
        if(ionic.Platform.isWebView()) {
 
          $rootScope.$on('$cordovaNetwork:online', function(event, networkState){
            console.log("went online 1");
          });
 
          $rootScope.$on('$cordovaNetwork:offline', function(event, networkState){
            console.log("went offline 1");
            cm.showNoConnectionAlert();
          });  
 
        } else {
 
          window.addEventListener("online", function(e) {
            console.log("went online 2 ");
          }, false);    
 
          window.addEventListener("offline", function(e) {
            console.log("went offline 2");
       	 }, false);
		}
	};

}])
srvtApp.controller('contactUsCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig', function($scope, $ionicNavBarDelegate, restAPIService, ServerConfig) {

  $scope.headOffice = null;
  $scope.$on("$ionicView.beforeEnter", function() {
	    $ionicNavBarDelegate.showBackButton(true);

	    if ($scope.headOffice == null)
	    	fetchContactInfo();
  });

  function fetchContactInfo() {
    var param = $scope.getCommonParams();

    restAPIService.sendRequest(ServerConfig.CONTACT_US, param)
    .then(function(response) {
      console.log ('Received response for getoperators');
      console.log (response);

      if (response.success == true) {
       	console.log(response);
       	$scope.headOffice = response.data[0];
       	// $scope.branches = response.data;
      } else {
       	console.log (response);
       	$scope.showAlert("Not Found", response.response.mappErrorResponse, function (){
       	});
      }

    }, 
    function (error) {
      console.log ('Failed to get Contact Info:' + error);
    });
  }

}])
srvtApp.service('dbService', ['$state', '$cordovaSQLite', '$q', function ($state, $cordovaSQLite, $q) {
	var loggedIn = false;

	var db = null;
	this.initDB = function () {
		try {
			db = $cordovaSQLite.openDB({name: "DB", location: "default"});
		} catch (error) {
			console.log('Error opening database');
		}

		return $cordovaSQLite.execute(db, 'CREATE TABLE IF NOT EXISTS Auth (id INTEGER PRIMARY KEY AUTOINCREMENT, registered INTEGER, mobile char(10))');
	};

	this.setIsRegistered = function (flag, mobileNo) {
		var deferred = $q.defer();

		var value = (flag === true) ? 1 : 0;
		if (flag === true) {
			/* Add value (1) for registered column in Auth Table */
	        $cordovaSQLite.execute(db, 'INSERT INTO Auth (registered, mobile) VALUES (?,?)', [value, mobileNo])
	        .then(function(result) {
	        	deferred.resolve();
	        	return deferred.promise;
	        }, function(error) {
	        	console.log ('Error writing to table:' + error);
	        	deferred.reject(error);
	        	return deferred.promise;
	        });
        } else {
			/* Delete All entries from Auth Table if flag is false */
	        $cordovaSQLite.execute(db, 'DELETE FROM Auth')
	        .then(function(result) {
	        	deferred.resolve();
	        	return deferred.promise;
	        }, function(error) {
	        	console.log ('Error writing to table:' + error);
	        	deferred.reject(error);
	        	return deferred.promise;
	        });
        }

        return deferred.promise;
	};

	this.getIsRegistered = function () {
		var deferred = $q.defer();

		if (db == null) {
			deferred.reject(false);
			return deferred.promise;
		}

        $cordovaSQLite.execute(db, 'SELECT * FROM Auth')
        .then(
            function(res) {

                if (res.rows.length > 0) {
                    if (res.rows.item(0).registered === 1) {
                    	deferred.resolve(true);
                    	return deferred.promise;
                    }
                }
            	deferred.reject(false);
                return deferred.promise;
            },
            function(error) {
                console.log ('Error reading from Auth table');
            	deferred.reject(error);
                return deferred.promise;
            }
        );
        return deferred.promise;
	};


	this.getUserMobile = function () {
		var deferred = $q.defer();

		if (db == null) {
        	deferred.reject('Could not read mobile number. Please reinstall the application.');
			return deferred.promise;
		}

        $cordovaSQLite.execute(db, 'SELECT * FROM Auth')
        .then(
            function(res) {

                if (res.rows.length > 0) {
                	var mobile = res.rows.item(0).mobile;
                	deferred.resolve(mobile);
                	return deferred.promise;
                }
            	deferred.reject();
                return deferred.promise;
            },
            function(error) {
                console.log ('Error reading from User table');
            	deferred.reject('Could not read mobile number. Please reinstall the application.');
                return deferred.promise;
            }
        );
        return deferred.promise;
	}
}])
srvtApp.controller('deregisterCtrl', ['$scope', '$ionicNavBarDelegate', '$ionicHistory', function($scope, $ionicNavBarDelegate, $ionicHistory) {

	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

	});
}])
srvtApp.service ('deviceInfo', ['$q', function ($q) {

	var _deviceInfo = this;

	this.getDeviceId = function () {

		var deferred = $q.defer();

		if (ionic.Platform.device().platform === "Android") {
		    if (window.plugins.sim) {

		    	var permissions = cordova.plugins.permissions;
		    	permissions.hasPermission(permissions.READ_PHONE_STATE, checkPermissionCallback, null);

				function checkPermissionCallback (status) {
				  if(!status.hasPermission) {
				    var errorCallback = function() {
				      console.log('Phone State permission is not turned on!');
				      ionic.Platform.exitApp();
				    }

				    permissions.requestPermission(
				      permissions.READ_PHONE_STATE,
				      function(status) {
				        if(!status.hasPermission) errorCallback();
				        else  {
				        	console.log ('Permission granted for PHONE State!');
				        	return readDeviceInfo();
				    	}
				      },
				      errorCallback);
				  } else {
				  	return readDeviceInfo();
				  }
				}

				function readDeviceInfo () {
				    window.plugins.sim.getSimInfo (function (result) {
				        console.log (result);
				        _deviceInfo.deviceId = result.deviceId;
				        _deviceInfo.subscriberId = result.subscriberId;
				        if (typeof (result.subscriberId) === "undefined" || typeof (result.deviceId) === "undefined") {
				        	deferred.reject('Failed to get SIM Info! Please insert a SIM to proceed.');
				        	return deferred.promise;
				        }
				        deferred.resolve(_deviceInfo);
				        return deferred.promise;
			      	}, function (error) {
				        console.log ("SIM Info Failed to get: ");
				        console.log (error);
				        deferred.reject('Failed to get SIM Status! Please insert a SIM to proceed.');
				        return deferred.promise;
			      	})
				    return deferred.promise;
				}
		    }
	    }
	    return deferred.promise;
	}

	this.getMacId = function() {
		var deferred = $q.defer();

	    if (window.MacAddress) {
	    	window.MacAddress.getMacAddress (function (macId) {
	    		console.log('Received MAC:' + macId);
	    		_deviceInfo.macId = macId.split(':').join('');
	    		deferred.resolve(macId);
	    		return deferred.promise;
	    	}, function (error) {
	    		console.log ('Failed to get MAC:' + error);
	    		deferred.reject('Failed to get MAC info!');
	    		return deferred.promise;
	    	});
	    }
	    return deferred.promise;
	}


	this.initialise = function () {
		var deferred = $q.defer();

		if (ionic.Platform.device().platform === "Android") {
			$q.all([
		      this.getDeviceId(),
		      this.getMacId()]
		    ).then(function (values) {
		      console.log('Received Values:');
		      console.log(values[0]);
		      console.log(values[1]);
   			  deferred.resolve();
   			  return deferred.promise;
		    }, function (error) {
		      console.log('Error getting deviceInfo:');
		      console.log (error);
		      $rootScope.showAlert('Error!', error, function () {
		        ionic.Platform.exitApp();
		      });
		      deferred.reject();
		      return deferred.promise;
		    })
		} else if (ionic.Platform.device().platform === "iOS") {
			_deviceInfo.deviceId = ionic.Platform.device().uuid;
			_deviceInfo.subscriberId = _deviceInfo.deviceId;
			_deviceInfo.macId = _deviceInfo.deviceId;
			deferred.resolve();

		} else if (ionic.Platform.device().platform === "browser") {
			_deviceInfo.deviceId = "352519051347261"; 
			_deviceInfo.subscriberId = "404909101127748"; 
			_deviceInfo.macId = "352519051347261"; 
			deferred.resolve();
		}

		return deferred.promise;
	}
}])
// srvtApp.factory('$exceptionHandler', ['$injector', function ($injector){
// 	return function (exception, cause) {
// 		var $ionicLoading = $injector.get('$ionicLoading');
// 		var $ionicPopup = $injector.get('$ionicPopup');
// 		$ionicLoading.hide();
// 	    var alert = $ionicPopup.alert({
//     		title: 'Error!',
//         	template: exception.message
//         });
//         alert.then(function(res) {});
// 	}
// }])
srvtApp.controller('forgotMPINCtrl', ['$scope', '$state','restAPIService', 'ServerConfig', '$q', 'secureStorage', 'deviceInfo', function($scope, $state, restAPIService, ServerConfig, $q, secureStorage, deviceInfo) {
	$scope.data = {};
  	$scope.mpinMismatch = false;

	$scope.submit = function (form) {

      if ($scope.data.mpin != $scope.data.mpin2) {
        $scope.mpinMismatch = true;
        return;
      }

      if (form.$invalid)
        return;

      $scope.hideKeyboard();

      var param = {
        // "mobileNo": "9860488395",
        "bank": ServerConfig.BANK_ID,
        "imei": deviceInfo.deviceId,
        "imsi": deviceInfo.subscriberId,
        "mac": deviceInfo.macId,
        "app-id": "1",
        "app-version" : "1",
      }

      param['pin'] = md5($scope.data.mpin);

      var promise1, promise2;

      if (ionic.Platform.device().platform == "browser") {
        promise1 = secureStorage.get("app-secret");
        promise2 = secureStorage.get("mobileNo");
      } else {
        promise1 = Auth.getAppToken();
        promise2 = dbService.getUserMobile();
      }

      $q.all([
        promise1,
        promise2
      ])
      .then(function (value) {

          param["app-secret"] = md5(param["app-id"] + value[0]);
          param["mobileNo"] = value[1];
          param["acc-validation-data"] = $scope.data.securityCode;

          restAPIService.sendRequest(ServerConfig.FORGOT_PIN, param)
          .then(function(response) {
            console.log ('Received response for FORGOT_PIN');
            console.log (response);

            if (response.success == true) {
          		$state.go('activation5', {showSuccessCard: true, successMessage:"MPIN reset successful"});
            } else {
              $scope.showAlert('Failed!', response.response["mappErrorResponse"], function(){});
            }
          });

      }, function (error) {
      	console.log('Error while reading from AppToken/MobileNo!');
      	console.log (error);
        var errorMsg;
        /* dbService will return a string in case of error */
        if (angular.isString(error)) {
          errorMsg = error;
        } else {

          if (typeof error.response !== "undefined" && typeof error.response.mappErrorResponse !== "undefined"){
            errorMsg = error.response['mappErrorResponse'];
          } else {
            errorMsg = "Failed to get response from Server.";
          }
        }

        $scope.showAlert("Login Failed!", errorMsg, function (res) {
        });
      });
	}
}])
srvtApp.controller('fundsTransferMainCtrl', ['$scope', '$ionicNavBarDelegate', function($scope, $ionicNavBarDelegate) {
  $ionicNavBarDelegate.showBackButton(true);
}])
srvtApp.controller('fundsTransferSuccessCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicNavBarDelegate', '$ionicPlatform','$rootScope', function($scope, $state, $stateParams, $ionicHistory, $ionicNavBarDelegate, $ionicPlatform, $rootScope) {

 	$ionicNavBarDelegate.showBackButton(false);

	$scope.RRN = $stateParams.bankTrnRRN;

	var deregisterHardwareBack = null;

	$scope.$on("$ionicView.beforeEnter", function() {
		$ionicHistory.removeBackView();

		deregisterHardwareBack = $ionicPlatform.registerBackButtonAction($scope.showHome, 101);
	});

	$scope.$on("$ionicView.beforeLeave", function() {

		/* Broadcast transferAgain to clear fields in funds transfer screen */
		$rootScope.$broadcast("transferAgain");

	});

	$scope.transferAgain = function () {

		$ionicHistory.goBack();
		// $ionicHistory.goBack(-3);
	}

	$scope.$on('$destroy', function () {
		if (deregisterHardwareBack != null)
			deregisterHardwareBack();
	});
}])
srvtApp.controller('homeCtrl', ['$scope', '$ionicNavBarDelegate','$ionicHistory', function($scope, $ionicNavBarDelegate, $ionicHistory) {

  $ionicNavBarDelegate.showBackButton(false);
  $ionicHistory.clearHistory();

}])
srvtApp.controller('imps2accountCtrl', ['$scope', '$state', '$stateParams', '$ionicNavBarDelegate', '$q', 'restAPIService', 'ServerConfig', 'beneficiaryModel','$rootScope', function($scope, $state, $stateParams, $ionicNavBarDelegate, $q, restAPIService, ServerConfig, beneficiaryModel, $rootScope) {

	$scope.selectedAccount = null;
	$scope.data = {};
	$scope.data.readOnly = false;
	$scope.acLable = "From A/c";

	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if ($scope.accounts.length == 0)
			$scope.getAccounts();

		if (beneficiaryModel.list != null) {
			$scope.beneList = beneficiaryModel.list;
		} else {
		    $q.when(beneficiaryModel.getList())
		    .then(function (list) {
		      $scope.beneList = list;
		    }, function (){

		    });
	    }

		$scope.onBeneChanged($stateParams.bene);
		
		if ($stateParams.bene != null)
			$scope.data.selectedBene = $stateParams.bene;
	});

	$rootScope.$on("transferAgain", function () {
	  $scope.data.selectedAccount = $scope.accounts[0];
	  $scope.data.selectedBene = null;
	  $scope.data.account = "";
	  $scope.data.ifsc = "";
	  $scope.data.amount = "";
	  $scope.data.remarks = "";
	  $scope.form.$setPristine();
	  $scope.form.$setUntouched();
	})

	$scope.setForm = function (form) {
		$scope.form = form;
	}

	$scope.onBeneChanged = function (selectedBene) {
		if (selectedBene != null) {
			$scope.data.account = selectedBene.account;
			$scope.data.ifsc = selectedBene.ifsc;
			$scope.data.readOnly = true;
		}
	}

	$scope.submit = function (form) {

	    if (form.$invalid)
	      return;

    	$scope.hideKeyboard();

	    var param = $scope.getCommonParams();
	    param['tran-type'] = 'Account';
	    param['amount'] = $scope.data.amount;

	    restAPIService.sendRequest(ServerConfig.GENERATE_OTP, param)
	    .then(function(response) {
	        console.log ('Received response for GENERATE_OTP in P2A');
	        console.log (response);

	        if (response.success == true) {
		    	$state.go('app.otpForTransaction', { txnType: 'P2A',
		    										 txnMsgDesc: param['tran-type'],
													remeAccount: $scope.data.selectedAccount.accountNo, 
													bene: { account: $scope.data.account, 
													 		ifsc: $scope.data.ifsc },
		    												amount: $scope.data.amount, 
		    												remarks:$scope.data.remarks});
	        } else {

	        	var errorMsg;
	        	if (typeof response.response !== "undefined" && typeof response.response.mappErrorResponse !== "undefined"){
	        		errorMsg = response.response['mappErrorResponse'];
	        	} else {
	        		errorMsg = "Failed to get response from Server.";
	        	}

	        	$scope.showAlert("Failed to Initiate IMPS Transaction!", errorMsg, function (res) {
	        	});
	        }
	    });
	}
}])
srvtApp.controller('imps2mobileCtrl', ['$scope', '$state', '$stateParams', '$ionicNavBarDelegate', '$q', 'restAPIService', 'ServerConfig', '$ionicPopup', 'beneficiaryModel', '$rootScope', function($scope, $state, $stateParams, $ionicNavBarDelegate, $q, restAPIService, ServerConfig, $ionicPopup, beneficiaryModel, $rootScope) {

	$scope.selectedAccount = null;
	$scope.data = {};
	$scope.data.readOnly = false;
	$scope.acLable = "From A/c";

	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if ($scope.accounts.length == 0)
			$scope.getAccounts();

		if (beneficiaryModel.list != null) {
			$scope.beneList = beneficiaryModel.list;
		} else {
		    $q.when(beneficiaryModel.getList())
		    .then(function (list) {
		      $scope.beneList = list;
		    }, function (){

		    });
	    }

		$scope.onBeneChanged($stateParams.bene);

		if ($stateParams.bene != null)
			$scope.data.selectedBene = $stateParams.bene;
	});

	$rootScope.$on("transferAgain", function () {
	  $scope.data.selectedAccount = $scope.accounts[0];
	  $scope.data.selectedBene = null;
	  $scope.data.mobile = "";
	  $scope.data.mmid = "";
	  $scope.data.amount = "";
	  $scope.data.remarks = "";
	  $scope.form.$setPristine();
	  $scope.form.$setUntouched();
	})

	$scope.setForm = function (form) {
		$scope.form = form;
	}

	$scope.onBeneChanged = function (selectedBene) {
		if (selectedBene != null) {
			$scope.data.mobile = selectedBene.mobile;
			$scope.data.mmid = selectedBene.mmid;
			$scope.data.readOnly = true;
		}
	}
	$scope.submit = function (form) {

	    if (form.$invalid)
	      return;

    	$scope.hideKeyboard();

	    var param = $scope.getCommonParams();
	    param['tran-type'] = 'Mobile';
	    param['amount'] = $scope.data.amount;

	    restAPIService.sendRequest(ServerConfig.GENERATE_OTP, param)
	    .then(function(response) {
	        console.log ('Received response for GENERATE_OTP in P2P');
	        console.log (response);

	        if (response.success == true) {
		    	$state.go('app.otpForTransaction', { txnType: 'P2P',
		    										 txnMsgDesc: param['tran-type'],
													 remeAccount: $scope.data.selectedAccount.accountNo, 
		    										 bene: { mobile: $scope.data.mobile, 
		    											 	 mmid: $scope.data.mmid },
		    												 amount: $scope.data.amount, 
		    												 remarks:$scope.data.remarks});
	        } else {
	        	var errorMsg;
	        	if (typeof response.response !== "undefined" && typeof response.response.mappErrorResponse !== "undefined"){
	        		errorMsg = response.response['mappErrorResponse'];
	        	} else {
	        		errorMsg = "Failed to get response from Server.";
	        	}

	        	$scope.showAlert("Failed to Initiate IMPS Transaction!", errorMsg, function (res) {
	        	});
	        }
	    });

	}
}])
srvtApp.controller('introCtrl', ['$scope', '$state', '$stateParams', 'ConnectivityMonitor', '$timeout', 'Auth', function($scope, $state, $stateParams, ConnectivityMonitor, $timeout, Auth) {

  $scope.$on("$ionicView.afterEnter", function() {

  	Auth.isRegistered()
  	.then(function () {
  		// User is registered; Splash screen will be hidden by SignIn screen
  	}, function () {
  		// User is not registered; Hide splash screen 
    	// navigator.splashscreen.hide();

  	});

    if ($stateParams.hideSplash == true)
      navigator.splashscreen.hide();

  });

  $scope.submit = function () {
    if (ConnectivityMonitor.isOnline()) {
      $state.go('activation1');
    } else {
      ConnectivityMonitor.showNoConnectionAlert();
    } 
  }
}])
srvtApp.controller('last5TxnsCtrl', ['$scope','$ionicNavBarDelegate', '$q', 'restAPIService', 'ServerConfig', function($scope, $ionicNavBarDelegate, $q, restAPIService, ServerConfig) {
	$ionicNavBarDelegate.showBackButton(true);

	$scope.data = {};
	$scope.data.selectedAccount = null;
	$scope.txns = null;


	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if ($scope.accounts.length == 0)
			$scope.getAccounts();
	});

	$scope.$on("$ionicView.afterEnter", function () {

		if ($scope.data.selectedAccount != null) {
			$scope.onAccountChanged($scope.data.selectedAccount);
		}
	})

	$scope.onAccountChanged = function (selectedAccount) {
		$scope.bankRRN = null;
		$scope.txns = null;

  		if (selectedAccount != null) {
	  	  // var param = commonParameters.get();
  	  	  var param = $scope.getCommonParams();

	  	  param['account-number'] = selectedAccount.accountNo;
		  param['mobileNo'] = selectedAccount.mobileNo;

	      restAPIService.sendRequest(ServerConfig.LAST_FIVE_TXNS, param)
	      .then(function(response) {
	        console.log ('Received response for LAST_FIVE_TXNS');
	        console.log (response);

	        if (response.success == true) {
	        	console.log();
	        	$scope.bankRRN = response.response['bankRRN'];

	        	var responseArray = JSON.parse(response.response.data);
	        	var length = responseArray.length;
	        	$scope.txns = [];
	        	for (var i = 0; i < length; i++) {
	        		var txn = responseArray[i];
	        		txn.transaction_entry = txn.transaction_entry.toUpperCase();
	        		txn.date = new Date (txn.transaction_datetime);
	        		$scope.txns.push(txn);
	        	}

	        } else {
	        	var errorMsg;
	        	if (typeof response.response !== "undefined" && typeof response.response.mappErrorResponse !== "undefined"){
	        		errorMsg = response.response['mappErrorResponse'];
	        	} else {
	        		errorMsg = "Failed to get data from Server.";
	        	}
	        	$scope.showAlert("Failed to get Last 5 Transactions!", errorMsg, function (res) {
	        	});
	        }
	      });
    	}  
    }
}])
srvtApp.service('logoutNotifier', ['$rootScope', function ($rootScope) {

	this.subscribe = function (scope, callback) {
		var handler = $rootScope.$on('logout', callback);
		if (scope != null)
			scope.$on('destroy', handler);
		else
			$rootScope.$on('destroy', handler);
	};

	this.notify = function () {
		$rootScope.$emit('logout');
	}
}])
srvtApp.controller('miniStatementCtrl', ['$scope','$ionicNavBarDelegate', '$q', 'restAPIService', 'ServerConfig', function($scope, $ionicNavBarDelegate, $q, restAPIService, ServerConfig) {
	$ionicNavBarDelegate.showBackButton(true);

	$scope.data = {};
	$scope.data.selectedAccount = null;

	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if ($scope.accounts.length == 0)
			$scope.getAccounts();
	});

	$scope.$on("$ionicView.afterEnter", function () {

		if ($scope.data.selectedAccount != null) {
			$scope.onAccountChanged($scope.data.selectedAccount);
		}
	})

	$scope.onAccountChanged = function (selectedAccount) {
		$scope.bankRRN = null;
		$scope.stmt = null;

  		if (selectedAccount != null) {
	  	  // var param = commonParameters.get();
  	  	  var param = $scope.getCommonParams();

	  	  param['account-number'] = selectedAccount.accountNo;
		  param['mobileNo'] = selectedAccount.mobileNo;

	      restAPIService.sendRequest(ServerConfig.MINI_STATEMENT, param)
	      .then(function(response) {
	        console.log ('Received response for MINI_STATEMENT');
	        console.log (response);

	        if (response.success == true) {
	        	console.log();
	        	$scope.bankRRN = response.response['bankRRN'];
	        	var message = response.response.message;
	        	var stmt = message.match(new RegExp('.{1,' + 41 + '}', 'g'));
	        	console.log ('Statement');
	        	console.log(stmt);
	        	var length = stmt.length;
	        	var txnTypeArray = [];
	        	for (var i=0; i < length; i++) {
	        		var str = stmt[i].trim();
	        		var strLength = str.length;
	        		var last3 = str.substr(str.length - 3, 3);
	        		if (last3.toLowerCase() === " cr") {
	        			txnTypeArray.push("Cr");
	        			var lastIndex = stmt[i].lastIndexOf("Cr");
	        			stmt[i] = stmt[i].substring(0, lastIndex);
	        		} else if (last3.toLowerCase() === " dr") {
	        			txnTypeArray.push("Dr");
	        			var lastIndex = stmt[i].lastIndexOf("Dr");
	        			stmt[i] = stmt[i].substring(0, lastIndex);
	        		} else
	        			txnTypeArray.push ("");
	        	}
	        	$scope.txnTypeArray = txnTypeArray;
	        	$scope.stmt = stmt;
	        } else {

	        	$scope.showAlert("Failed to get Mini Statement!", response.response['mappErrorResponse'], function (res) {
	        	});
	        }
	      });
    	}  
    }
}])
srvtApp.controller('myAccountMainCtrl', ['$scope', '$ionicNavBarDelegate', function($scope, $ionicNavBarDelegate) {
  $ionicNavBarDelegate.showBackButton(true);
}])
srvtApp.controller('neft2accountCtrl', ['$scope', '$state', '$stateParams', '$ionicNavBarDelegate', '$q', 'restAPIService', 'ServerConfig', 'beneficiaryModel', '$rootScope', function($scope, $state, $stateParams, $ionicNavBarDelegate, $q, restAPIService, ServerConfig, beneficiaryModel, $rootScope) {

	$scope.selectedAccount = null;
	$scope.data = {};
	$scope.data.readOnly = false;
	$scope.acLable = "From A/c";

	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if ($scope.accounts.length == 0)
			$scope.getAccounts();

		if (beneficiaryModel.list != null) {
			$scope.beneList = beneficiaryModel.list;
		} else {
		    $q.when(beneficiaryModel.getList())
		    .then(function (list) {
		      $scope.beneList = list;
		    }, function (){

		    });
	    }

		$scope.onBeneChanged($stateParams.bene);

		if ($stateParams.bene != null)
			$scope.data.selectedBene = $stateParams.bene;
	});

	$rootScope.$on("transferAgain", function () {
	  $scope.data.selectedAccount = $scope.accounts[0];
	  $scope.data.selectedBene = null;
	  $scope.data.account = "";
	  $scope.data.ifsc = "";
	  $scope.data.amount = "";
	  $scope.data.remarks = "";
	  $scope.form.$setPristine();
	  $scope.form.$setUntouched();
	})

	$scope.setForm = function (form) {
		$scope.form = form;
	}

	$scope.onBeneChanged = function (selectedBene) {
		if (selectedBene != null) {
			$scope.data.account = selectedBene.account;
			$scope.data.ifsc = selectedBene.ifsc;
			$scope.data.readOnly = true;
		}
	}

	$scope.submit = function (form) {

	    if (form.$invalid)
	      return;

		$scope.hideKeyboard();

	    var param = $scope.getCommonParams();
	    param['tran-type'] = 'NEFT';
	    param['amount'] = $scope.data.amount;

	    restAPIService.sendRequest(ServerConfig.GENERATE_OTP, param)
	    .then(function(response) {
	        console.log ('Received response for GENERATE_OTP in NEFT');
	        console.log (response);

	        if (response.success == true) {
		    	$state.go('app.otpForTransaction', { txnType: 'NEFT',
		    										 txnMsgDesc: param['tran-type'],
	    											 remeAccount: $scope.data.selectedAccount.accountNo, 
	    											 bene: { account: $scope.data.account, 
	    											 		 ifsc: $scope.data.ifsc },
	    											 		amount: $scope.data.amount, 
	    											 		remarks:$scope.data.remarks});
	        } else {
	        	var errorMsg;
	        	if (typeof response.response !== "undefined" && typeof response.response.mappErrorResponse !== "undefined"){
	        		errorMsg = response.response['mappErrorResponse'];
	        	} else {
	        		errorMsg = "Failed to get response from Server.";
	        	}

	        	$scope.showAlert("Failed to Initiate NEFT Transaction!", errorMsg, function (res) {
	        	});
	        }
	    });

	}

}])
.controller('newCardRequestCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig',function ($scope, $ionicNavBarDelegate, restAPIService, ServerConfig) {

	$scope.data = {};
	$scope.data.cards = [{ name: "Rupay Debit Card", type: "RupayDebitCard"},
						 { name: "Rupay Gold Card", type: "RupayGoldCard"},
						 { name: "Rupay Platinum Card", type: "RupayPlatinumCard"},
						 { name: "Rupay Kissan Card (KCC)", type:"RupayKissanCard"}];

	$scope.data.selectedCardType = $scope.data.cards[0].type;

	$scope.$on("$ionicView.beforeEnter", function() {
		/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

	    if ($scope.accounts.length == 0)
	      $scope.getAccounts();

	});

	$scope.submit = function (form) {

		if (form.$invalid)
			return;

    	var param = $scope.getCommonParams();

    	param['subject'] = 'new-card-request';
    	param['card-type'] = $scope.data.selectedCardType
    	param['account-number'] = $scope.data.selectedAccount.accountNo;

	    restAPIService.sendRequest(ServerConfig.APPLY_ONLINE, param)
	    .then(function(response) {
	      console.log ('Received response for applyNow');
	      console.log (response);

	      if (response.success == true) {
	       	console.log('Apply Now Successful!');
	       	console.log(response);
	       	$scope.showAlert("Request Sent", "Your request for new Card is sent to the bank.", function () {
	       		$scope.showHome();
	       	});
	      } else {
	       	console.log ('Apply Now Failed:');
	       	console.log (response);
	       	$scope.showAlert("Failed to Apply", response.response.mappErrorResponse, function (){
	       	});
	      }

	    },
	    function (error) {
	      console.log ('Failed to ApplyNow:' + error);
	    });
	}

}])
srvtApp.service ('operatorsModel', ['restAPIService', 'Auth', '$q', 'commonParameters', 'ServerConfig' ,function (restAPIService, Auth, $q, commonParameters, ServerConfig) {

	mobileOperators = {};
  dthOperators = {};

	this.getOperators = function (service) {

      if (service.type === ServerConfig.SERVICE_TYPE_DTH && dthOperators.length > 0) {
        return dthOperators;
      } else {
        if (service.type === ServerConfig.SERVICE_TYPE_MOBILE && mobileOperators.length > 0) {
          return mobileOperators;
        }
      }

		  var deferred = $q.defer();

		  var param = commonParameters.get();

      var requestUrl;
      if (service.type === ServerConfig.SERVICE_TYPE_DTH)
        requestUrl = ServerConfig.GET_DTH_OPERATORS;
      else
        requestUrl = ServerConfig.GET_OPERATORS;

      restAPIService.sendRequest(requestUrl, param)
      .then(function(response) {
        console.log ('Received response for getoperators');
        console.log (response);

        if (response.success == true) {
        	console.log('operators fetched!');
        	console.log(response);

          if (service.type === ServerConfig.SERVICE_TYPE_DTH) {
            dthOperators = response.data;
        	  deferred.resolve(dthOperators);
          } else {
            mobileOperators = response.data;
            deferred.resolve(mobileOperators);
          }
        } else {
        	deferred.reject(response);
        }
        return deferred.promise;

        }, 
        function (error) {
        	deferred.reject(error);
        	return deferred.promise;
        }
      );

      return deferred.promise;
  }
}])
srvtApp.controller('otpActivationCtrl', ['$scope', '$state', 'restAPIService', 'ServerConfig', 'secureStorage', '$interval', 'Auth', '$ionicHistory', function($scope, $state, restAPIService, ServerConfig, secureStorage, $interval, Auth, $ionicHistory) {

  $scope.data = {};
  $scope.data.mpin = "";
  $scope.data.mpin2 = "";
  $scope.waitCount = ServerConfig.OTP_WAIT_TIME;
  $scope.mpinMismatch = false;

 function CountDownTimer(scope) {
  var timerPromise;
  var instance = this;

  function counterEnd () {
    $interval.cancel(timerPromise);
    $scope.waitCount = 0;
  }

  function decrementCounter () {
    if (scope.waitCount <= 0) {
      counterEnd();
      return;
    }
    scope.waitCount--;
  }

  this.start = function () {
    clearInterval(timer);
    scope.waitCount = ServerConfig.OTP_WAIT_TIME;
    timerPromise = $interval (decrementCounter, 1000);
  }

  this.stop = function () {
    counterEnd();
  }
}

  timer = new CountDownTimer ($scope);
  timer.start();

  $scope.mpin2Changed = function () {
    $scope.mpinMismatch = false;
  }

  $scope.submit = function (form) {

    if (form.mpin.$viewValue.length == 0 || form.mpin2.$viewValue.length == 0) {
      return;
    } else if ($scope.data.mpin != $scope.data.mpin2) {
      $scope.mpinMismatch = true;
      return;
    }
    
    if (form.$invalid)
      return;

    timer.stop();

    $scope.hideKeyboard();

    console.log ('OTP' + $scope.data.otp);
    console.log ('MPIN' + $scope.data.mpin);
    console.log ('MPIN2' + $scope.data.mpin2);

    var param = $scope.getCommonParams();
    param["app-secret"] = md5(param["app-id"] + $scope.data.otp);

    restAPIService.sendRequest(ServerConfig.VERIFY_OTP, param)
    .then(function (response) {

      console.log ('Received Response in Controller activation4Ctrl');
      console.log (response);

      if (response.success == true) {
        // var param = {
        //   "mobileNo": "9860488395",
        //   "bank": "999",
        //   "imei": "352519051347261",
        //   "imsi": "404909101127748",
        //   "mac": "352519051347261",
        //   "acc-validation-data" : "0000971990",
        //   "app-id": "1",
        // }

        param["pin"] = md5($scope.data.mpin);
        param["app-secret"] = md5(param["app-id"] + response.response["app-token"]);

        Auth.setAppToken(response.response["app-token"]);

        if (ionic.Platform.device().platform == "browser") {
          secureStorage.set("app-secret", response.response["app-token"]);
          secureStorage.set("mobileNo", param["mobileNo"]);
        }

        restAPIService.sendRequest(ServerConfig.SET_PIN, param)
        .then(function(response) {
          console.log ('Received response for set-pin');
          console.log (response);

          Auth.setIsRegistered(true, param["mobileNo"]);

          $ionicHistory.nextViewOptions({
            disableBack: true,
            historyRoot: true
          });
          $state.go('activation5', {showSuccessCard: true, successMessage:"Activation successful"});
        });

      } else {
          $scope.showAlert('Error!', response.response["mappErrorResponse"], function () {
          });
      }
    });

  };

  $scope.resendClicked = function () {
      // $scope.waitCount = 30;
      timer.start();
      var param = $scope.getCommonParams();

      restAPIService.sendRequest(ServerConfig.REGISTER, param)
      .then(function (response) {
        console.log ('Received Response in Controller ' + response);
        if (response.success == true) {
          /* Stay on the same screen for successful response */
        } else {
          $scope.showAlert('Error!', 'Failed to Register: Invalid mobile no or security code', function () {
          });
        }
      });
  }

  $scope.$on("$destroy", function handler() {
    timer.stop();
  });
}])

srvtApp.controller('otpTransactionCtrl', ['$scope', '$state', '$stateParams', 'restAPIService', 'ServerConfig', '$timeout', '$interval', '$ionicHistory', function($scope, $state, $stateParams, restAPIService, ServerConfig, $timeout, $interval, $ionicHistory) {

$scope.data = {};
  $scope.waitCount = ServerConfig.OTP_WAIT_TIME;
  $scope.mpinMismatch = false;

 function CountDownTimer(scope) {
  var timerPromise;
  var instance = this;

  function counterEnd () {
    $interval.cancel(timerPromise);
    $scope.waitCount = 0;
  }

  function decrementCounter () {
    if (scope.waitCount <= 0) {
      counterEnd();
      return;
    }
    scope.waitCount--;
  }

  this.start = function () {
    clearInterval(timer);
    scope.waitCount = ServerConfig.OTP_WAIT_TIME;
    timerPromise = $interval (decrementCounter, 1000);
  }

  this.stop = function () {
    counterEnd();
  }
}

  timer = new CountDownTimer ($scope);
  timer.start();

function fundsTransfer(requestURL, param, successCb) {
  restAPIService.sendRequest(requestURL, param)
  .then(function(response) {
    console.log (response);

    if (response.success == true) {
      console.log ('Transaction successful');
      if (successCb)
        successCb(response);
    } else {

      $scope.showAlert('Transaction Failed!', response.response['mappErrorResponse'], function () {
        // $ionicHistory.goBack(-2);
      });
    }
  });
}

function neftSuccess (response) {
  $state.go('app.fundsTransferSuccess', {bankTrnRRN: response.response.bankRRN});
}

$scope.submit = function (form) {

  if (form.$invalid)
  return;

  $scope.hideKeyboard();

  var param = $scope.getCommonParams();

  param['otp'] = $scope.data.otp;
  param['password'] = md5($scope.data.mpin);
  param['amount'] = $stateParams.amount;
  param['time-stamp'] = $scope.getTimeStamp();
  param['seq-number'] = $scope.getSequenceNo();
  param['remarks'] = $stateParams.remarks;
  param['tran-type'] = $stateParams.txnMsgDesc;

  if ($stateParams.txnType == 'NEFT') {

    param['account'] = $stateParams.remeAccount;
    param['bene-account'] = $stateParams.bene.account;
    param['bene-ifsc-code'] = $stateParams.bene.ifsc;
    console.log(param);

    fundsTransfer(ServerConfig.NEFT, param, neftSuccess);
  } else if ($stateParams.txnType == 'P2A') {
    param['account'] = $stateParams.remeAccount;
    param['bene-account'] = $stateParams.bene.account;
    param['bene-ifsc-code'] = $stateParams.bene.ifsc;

    console.log(param);

    fundsTransfer(ServerConfig.IMPS2ACCOUNT, param, neftSuccess);
  } else if ($stateParams.txnType == 'P2P') {
    param['account-number'] = $stateParams.remeAccount;
    param['bene-mobile'] = $stateParams.bene.mobile;
    param['bene-mmid'] = $stateParams.bene.mmid;
   
    console.log(param);

    fundsTransfer(ServerConfig.IMPS2MOBILE, param, neftSuccess);
  }
}


  $scope.resendClicked = function () {
      // $scope.waitCount = 30;
      timer.start();
      var param = $scope.getCommonParams();

      param['amount'] = $stateParams.amount;
      param['tran-type'] = $stateParams.txnMsgDesc;

      restAPIService.sendRequest(ServerConfig.GENERATE_OTP, param)
      .then(function (response) {
        console.log ('Received Response in Controller ' + response);
        if (response.success == true) {
          /* Stay on the same screen for successful response */
        } else {
          $scope.showAlert('Error!', 'Failed to generate OTP. Please try again later.', function () {
          });
        }
      });
  }

  $scope.$on("$destroy", function handler() {
    timer.stop();
  });


}])

srvtApp.controller('photoCtrl', ['$scope', '$cordovaCamera', '$state', '$cordovaFile', '$q', function($scope, $cordovaCamera, $state, $cordovaFile, $q) {
	
  $scope.showCameraImage = false;
  var PROFILE_IMG_FILE = "profile.img";


  function saveImage(imageURI) {
	  var sourceDirectory = imageURI.substring(0, imageURI.lastIndexOf('/') + 1);
      var sourceFileName = imageURI.substring(imageURI.lastIndexOf('/') + 1, imageURI.length);

      /* Remove trailing query string if any */
      if (sourceFileName.lastIndexOf('?') > -1)
     	 sourceFileName = sourceFileName.substring(0, sourceFileName.lastIndexOf('?'));

      /* Check if profile image exists */
      $cordovaFile.checkFile (cordova.file.dataDirectory, PROFILE_IMG_FILE)
      .then(function (success) {
      		console.log ('Old profile img found.');

      		/* Remove it if it exists */
      		var deferred = $q.defer();
      		$cordovaFile.removeFile (cordova.file.dataDirectory, PROFILE_IMG_FILE)
      		.then (function (success) {
	      		console.log ('Old profile img removed!!');

      			deferred.resolve(success);
      		}, function (err) {
	      		console.log ('Old profile img could not be removed!!' + err);

      			deferred.resolve(success);
      		});

      		return deferred.promise;
      }, function (err) {
      		/* Can copy new profile image if file not found */
      		console.log ('Old profile img not found.');
  			var deferred = $q.defer();
  			deferred.resolve(true);
  			return deferred.promise;
      })
      .then (function () {
      		console.log ('Copying new image as profile image!!');
      		/* Copy file to destination */
      		return $cordovaFile.copyFile(sourceDirectory, sourceFileName, cordova.file.dataDirectory, PROFILE_IMG_FILE);
      }) 
      .then (function (success) {
      	console.log ('Copied image to Destination.');
      }, function (error) {
      	console.log ('Failed to Copy image to Destination.' + error);
      });

  }

  $scope.takePicture = function () {
    var options = {
      quality: 75,
      destinationType: Camera.DestinationType.FILE_URI,
      sourceType: Camera.PictureSourceType.CAMERA,
      allowEdit: true,
      encodingType: Camera.EncodingType.JPEG,
      targetWidth: 300,
      targetHeight: 300,
      cameraDirection: 1,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false
    };

    $cordovaCamera.getPicture(options).then(function (imageURI) {
    	console.log('Selected imageURI' + imageURI);
    	saveImage(imageURI);
      $scope.imgURI = imageURI;
      $scope.showCameraImage = true;
      //$scope.nextStep();
    }, function (err) {
      // An error occured. Show a message to the user
    });
  };

  $scope.selectPicture = function () {
    var options = {
      quality: 75,
      destinationType: Camera.DestinationType.FILE_URI,
      sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
      allowEdit: true,
      encodingType: Camera.EncodingType.JPEG,
      targetWidth: 300,
      targetHeight: 300,
      cameraDirection: 1,
      popoverOptions: CameraPopoverOptions,
      saveToPhotoAlbum: false
    };

    $cordovaCamera.getPicture(options).then(function (imageURI) {
      saveImage(imageURI);
      $scope.imgURI = imageURI;
      $scope.showCameraImage = true;
      //$scope.nextStep();
    }, function (err) {
      // An error occured. Show a message to the user
    });
  };

  $scope.nextStep = function () {
    $state.go('activateStep3', {}, {reload: true});
  }

}])
srvtApp.controller('rechargeCtrl', ['$scope', '$state', '$stateParams', '$ionicNavBarDelegate', '$q', 'operatorsModel', 'ServerConfig', '$ionicHistory', '$rootScope', function($scope, $state, $stateParams, $ionicNavBarDelegate, $q, operatorsModel, ServerConfig, $ionicHistory, $rootScope) {

  $scope.data = {};
  $scope.operators = [];
  $scope.data.title = "Recharge"

  $scope.$on("$ionicView.beforeEnter", function() {
    /* Added here so that back button is visible even if the view is loaded from cache */
    $ionicNavBarDelegate.showBackButton(true);

    if (typeof ($scope.data.customerNo) == "undefined" || $scope.data.customerNo.length == 0) {

      if ($stateParams.recharge == false) {
        $scope.data.title = "Bill Pay";
        $scope.services = [{'name': "Mobile",
                            'type' : "M"},
                           {'name' : "Data Card",
                            'type' : "M"}];
      } else {
        $scope.services = [{'name': "Mobile",
                            'type' : "M"},
                           {'name' : "DTH",
                            'type' : "D"},
                           {'name' : "Data Card",
                            'type' : "M"}];
      }

      $scope.data.selectedService = $scope.services[0];
    }

    if ($scope.accounts.length == 0)
      $scope.getAccounts();

    /* Get Operators when view is loaded first time */
    if ($scope.operators.length == 0) {
      updateOperators($scope.data.selectedService);
    }

  });

  $rootScope.$on("rechargeAgain", function () {
      $scope.data.selectedService = $scope.services[0];
      updateOperators ($scope.data.selectedService);
      $scope.data.selectedOperator = null;
      $scope.data.selectedAccount = $scope.accounts[0];
      $scope.data.customerNo = "";
      $scope.data.amount = "";
      $scope.form.$setPristine();
      $scope.form.$setUntouched();
  })

  $scope.setForm = function (form) {
    $scope.form = form;
  }

  function updateOperators (selectedService) {
    $q.when(operatorsModel.getOperators(selectedService))
    .then(function (operators) {
    	console.log ('Update Operators : operators ->!');
    	console.log (operators);
    	$scope.operators = operators;
    }, function () {

    });
  }

  $scope.onServiceChanged = function (selectedService) {
    updateOperators(selectedService);
    $scope.data.customerNo = "";
  }

  $scope.submit = function (form) {

    if (form.$invalid)
      return;

    $scope.hideKeyboard();

    var param = $scope.getCommonParams();
    param['bene-type'] = $scope.data.selectedService.type;
    param['bene-value'] = $scope.data.customerNo;
    param['operator'] = $scope.data.selectedOperator.operatorName;
    param['amount'] = $scope.data.amount;
    param['reme-account'] = $scope.data.selectedAccount.accountNo;

    $state.go("app.rechargeMpin", {"rechargeInfo": param, "recharge": $stateParams.recharge}, {reload: true});

  }

}])
srvtApp.controller('rechargeMpinCtrl', ['$scope', '$state', '$stateParams', 'restAPIService', 'ServerConfig', '$ionicHistory',function($scope, $state, $stateParams, restAPIService, ServerConfig, $ionicHistory) {

	$scope.data = {};
	$scope.title = "Recharge";
	
    if ($stateParams.recharge == false) {
      $scope.title = "Bill Pay";
    }

	$scope.submit = function(form) {

		if (form.$invalid)
			return;

    	$scope.hideKeyboard();

		console.log ('Received StateParams: ');
		console.log ($stateParams);
		var param = $stateParams.rechargeInfo;
		param['password'] = md5($scope.data.mpin);
		param['time-stamp'] = $scope.getTimeStamp();
		param['seq-number'] = $scope.getSequenceNo();

		var requestURL;
		if ($stateParams.recharge == false) {
			requestURL = ServerConfig.BILL_PAY;
		} else {
			requestURL = ServerConfig.RECHARGE
		}

	    restAPIService.sendRequest(requestURL, param)
	    .then(function(response) {
	      console.log ('Received response for getoperators');
	      console.log (response);

	      if (response.success == true) {
	       	console.log('Recharge Successful!');
	       	console.log(response);
	       	$state.go('app.rechargeSuccess', {"response": response, "merchantRefNo" : response.response.MerchantReferenceNo, 
	       		"bankRefNo" : response.response.bankRRN, "recharge" : $stateParams.recharge}, {reload: true});
	      } else {
	       	console.log ('Recharge Failed:');
	       	console.log (response);
	       	// $scope.showAlert("Failed to Recharge", response.response.mappErrorResponse, function (){
	       	// });
	       	$state.go('app.rechargeSuccess', {"response": response, "merchantRefNo" : response.response.MerchantReferenceNo, 
	       		"bankRefNo" : response.response.bankRRN, "recharge" : $stateParams.recharge}, {reload: true});

	      }

	    }, 
	    function (error) {
	      console.log ('Failed to Recharge:' + error);
	    });
	}

	$scope.onCancelClicked = function () {
    	$ionicHistory.goBack(-2);
	}
}])
srvtApp.controller('rechargeSuccessCtrl', ['$scope', '$state', '$stateParams', '$ionicHistory', '$ionicNavBarDelegate', '$ionicPlatform', '$rootScope', function($scope, $state, $stateParams, $ionicHistory, $ionicNavBarDelegate, $ionicPlatform, $rootScope) {
 	$ionicNavBarDelegate.showBackButton(false);

	$scope.title = "Recharge";
	
	var deregisterHardwareBack = null;

    if ($stateParams.recharge == false) {
      $scope.title = "Bill Pay";
    }

    $scope.response = $stateParams.response;
	$scope.merchantRefNo = $stateParams.merchantRefNo;
	$scope.bankRefNo = $stateParams.bankRefNo;

	$scope.$on("$ionicView.beforeEnter", function() {
		$ionicHistory.removeBackView();

		deregisterHardwareBack = $ionicPlatform.registerBackButtonAction($scope.showHome, 101);

	});

	$scope.rechargeAgain = function () {
		// var historyList = $ionicHistory.viewHistory();
		// var backViewId = $ionicHistory.currentView().historyId;
		// var history = historyList.histories[backViewId];
		// var length = history.stack.length;
		// history.stack.splice(2, length - 2);
		// history.cursor = 1;
		// historyList.backView = history.stack[1];
		// historyList.backView.forwardViewId = null;
		// historyList.backView.stateParams = {recharge: $stateParams.recharge, comingBack: true};

		// $rootScope.$broadcast("rechargeAgain");
		// $ionicHistory.goBack();

		$ionicHistory.goBack();
		$rootScope.$broadcast("rechargeAgain");

		// var rechargeViewId = historyList[backViewId].backViewId;
		// var rechargeView = historyList[rechargeViewId];

		// rechargeView.stateParams = {recharge: $stateParams.recharge, comingBack: true};

		// $ionicHistory.backView().stateParams = {recharge: $stateParams.recharge, comingBack: true};
		// $ionicHistory.goBack(-2);

	}

	$scope.showHome = function () {
		$rootScope.showHome();
		/* Broadcast recharge again to clear fields */
		$rootScope.$broadcast("rechargeAgain");
	}

	$scope.$on('$destroy', function () {
		if (deregisterHardwareBack != null)
			deregisterHardwareBack();
	});
}])
srvtApp.controller('registrationCtrl', ['$scope', '$state', '$ionicPopup', 'restAPIService', 'ServerConfig', 'commonParameters', 'secureStorage', '$timeout', 'deviceInfo', function($scope, $state, $ionicPopup, restAPIService, ServerConfig, commonParameters, secureStorage, $timeout, deviceInfo) {
  $scope.invalidMobile = false;
  $scope.invalidSecurityCode = false;
  $scope.data = {};
  $scope.data.checked = false;

  $scope.checkboxChanged = function (checked) {
    $scope.hideKeyboard();
  }

  $scope.submit = function (form) {

    if (form.$valid && $scope.data.checked == true) {

      $scope.hideKeyboard();

      secureStorage.initialise();

      param = {
        "mobileNo": $scope.data.mobileNo,
        "bank": ServerConfig.BANK_ID,
        "imei": deviceInfo.deviceId,
        "imsi": deviceInfo.subscriberId,
        "mac": deviceInfo.macId,
        "app-id": "1",
        "app-version" : "1",
        "acc-validation-data" : $scope.data.securityCode
      }
      commonParameters.set(param);

      restAPIService.sendRequest(ServerConfig.REGISTER, param)
      .then(function (response) {
        console.log ('Received Response in Controller ' + response);
        if (response.success == true)
          $state.go('activation2');
        else {
          var alert = $ionicPopup.alert({
            title: 'Error!',
            template: 'Failed to Register: Invalid mobile no or security code'
          });

          alert.then(function (response) {
          });
        }
      });
    }
  }
}])
srvtApp.service('restAPIService', ['$http', 'ServerConfig', '$ionicLoading', '$q', function ($http, ServerConfig, $ionicLoading, $q) {
	this.sendRequest = function (URL, param) {

		// $ionicLoading.show();
		var deferred = $q.defer();
		 $http({	 method:'POST',
					url: URL,
				transformRequest: function (obj) {
							        var str = [];
							        for(var p in obj)
							        	str.push(encodeURIComponent(p) + "=" + encodeURIComponent(obj[p]));

							        return str.join("&");
							    	},
					data: param
				})
	   .then(
	   		 function(response) {
					// $ionicLoading.hide();
	   		 	console.log ('Response Received.');
	   		 	console.log(response);
	   		 	deferred.resolve(response.data);
	   		 	return deferred.promise;
	   		 }, function (error) {
					// $ionicLoading.hide();
					console.log ('Error Received:');
					console.log (error);
					deferred.reject(error);
					return deferred.promise;
	   		 });

	   return deferred.promise;
	   }
	
}])
srvtApp.service('secureStorage', ['$ionicPlatform', '$q', function ($ionicPlatform, $q) {

	var ss;

	this.initialise = function () {
		var deferred = $q.defer();

		ss = new cordova.plugins.SecureStorage (
             function () { 
             	console.log('Success: initialiseed SecureStorage!');
             	deferred.resolve();
             	return deferred.promise;
             },
             function (error) { 
             	console.log('Error Initialising SecureStorage: ' + error); 
             	deferred.reject(error);
             	return deferred.promise;
             },
             'my_app'
            );
		return deferred.promise;
	}

	this.set = function(key, value) {
	        ss.set(
		        function (key) { console.log('Set ss:' + key); },
		        function (error) { console.log('Error setting ss:' + error); },
		        key, value);
	}

	this.get = function(key) {
		var deferred = $q.defer();

		ss.get(
			    function (value) { 
			    	console.log('Success, got ' + value); 
			    	deferred.resolve(value);
			    	return deferred.promise;
			    },
			    function (error) { 
			    	console.log('Error ' + error);
			    	deferred.reject(error);
			    	return deferred.promise;
			    },
			    key);
		return deferred.promise;
	}

	this.remove = function (key) {
		var deferred = $q.defer();

		ss.remove(
			    function (key) { 
			    	console.log('Success, Removed ' + key); 
			    	deferred.resolve(true);
			    	return deferred.promise;
			    },
			    function (error) { 
			    	console.log('Error ' + error);
			    	deferred.reject(error);
			    	return deferred.promise;
			    },
			    key);
		return deferred.promise;
	}
}])
srvtApp.controller('showMMIDCtrl', ['$scope', '$state', '$ionicNavBarDelegate', '$q', 'restAPIService', 'ServerConfig', function($scope, $state, $ionicNavBarDelegate, $q, restAPIService, ServerConfig) {

	$scope.data = {};
	$scope.data.selectedAccount = null;

	$scope.$on("$ionicView.beforeEnter", function() {
	/* Added here so that back button is visible even if the view is loaded from cache */
		$ionicNavBarDelegate.showBackButton(true);

		if ($scope.accounts.length == 0)
			$scope.getAccounts();
	});

	$scope.$on("$ionicView.afterEnter", function () {

		if ($scope.data.selectedAccount != null) {
			$scope.onAccountChanged($scope.data.selectedAccount);
		}
	})

	$scope.onAccountChanged = function (selectedAccount) {
		// $scope.bankRRN = null;
		// $scope.result = null;

  // 		if (selectedAccount != null) {
	 //  	  // var param = commonParameters.get();
  // 	  	  var param = $scope.getCommonParams();

	 //  	  param['account-number'] = selectedAccount.accountNo;
		//   param['mobileNo'] = selectedAccount.mobileNo;

	 //      restAPIService.sendRequest(ServerConfig.RETRIEVE_MMID, param)
	 //      .then(function(response) {
	 //        console.log ('Received response for RETRIEVE_MMID');
	 //        console.log (response);

	 //        if (response.success == true) {
	 //        	console.log();
	 //        	$scope.result = response.response.RemitterMMID;
	 //        	// $scope.bankRRN = response.response['bankRRN'];
	 //        } else {

	 //        	$scope.showAlert("Failed to get MMID!", response.response['mappErrorResponse'], function (res) {
	 //        	});
	 //        }

	 //      });
  //   	}  
    }

    // $scope.submit = function () {
    // 	$state.go('app.cancelMMID', {selectedAccount: $scope.data.selectedAccount});
    // }
}])
srvtApp.controller('signInCtrl', ['$scope', '$state', '$stateParams','restAPIService', 'ServerConfig', 'secureStorage', 'Auth', 'ConnectivityMonitor', '$ionicPopup', 'accountsModel', 'commonParameters', '$q', '$ionicHistory', 'beneficiaryModel', 'deviceInfo', 'dbService', function($scope, $state, $stateParams, restAPIService, ServerConfig, secureStorage, Auth, ConnectivityMonitor, $ionicPopup, accountsModel, commonParameters, $q, $ionicHistory, beneficiaryModel, deviceInfo, dbService) {
  $scope.data = {};
  $scope.showSuccessCard = $stateParams.showSuccessCard;
  $scope.successMessage = $stateParams.successMessage;
  

  $scope.$on("$ionicView.afterEnter", function() {

    if ($stateParams.hideSplash == true)
      navigator.splashscreen.hide();

  });

  // $scope.$on("$ionicView.beforeEnter", function() {

  //   Auth.getAppToken()
  //   .then(function (appToken) {
  //     console.log ('Received App Token:' + appToken);
  //   }, function () {
  //     console.log ('Failed to get App Token!!');
  //   });

  // });

  $scope.submit = function (form) {
    // var param = commonParameters.get();

    if (ConnectivityMonitor.isOnline()) {

      if (form.$invalid)
        return;

      $scope.hideKeyboard();

        // $state.go('app.home');
        // return;
               
      var param = {
        // "mobileNo": "9860488395",
        "bank": ServerConfig.BANK_ID,
        "imei": deviceInfo.deviceId,
        "imsi": deviceInfo.subscriberId,
        "mac": deviceInfo.macId,
        "app-id": "1",
        "app-version" : "1",
      }
      param['pin'] = md5($scope.data.mpin);

      var promise1, promise2;

      if (ionic.Platform.device().platform == "browser") {
        promise1 = secureStorage.get("app-secret");
        promise2 = secureStorage.get("mobileNo");
      } else {
        promise1 = Auth.getAppToken();
        promise2 = dbService.getUserMobile();
      }


      $q.all([
        promise1, promise2
        // secureStorage.get("app-secret"),
        // secureStorage.get("mobileNo"),
        // Auth.getAppToken(),
        // dbService.getUserMobile()
        // secureStorage.remove('app-secret')
      ])
      .then(function (value) {
          console.log("Received Value for app-token =" + value[0]);
          param["app-secret"] = md5('1' + value[0]);
          param["mobileNo"] = value[1];
          restAPIService.sendRequest(ServerConfig.LOGIN, param)
          .then(function(response) {
            console.log ('Received response for Login');
            console.log (response);

            if (response.success == true) {
              Auth.setLoggedIn(true);

              commonParameters.set(param);

              $q.when($scope.getAccounts())
              .then(function (res) {
                console.log ('Received Accounts! (signInCtrl)');
                $ionicHistory.nextViewOptions({
                  historyRoot: true
                });

                $state.go('app.home');
              }, function(err) {
                console.log ('Error getting Accounts (signInCtrl)');
                console.log(err);
                $scope.showAlert("Failed to get Account details!", "Please try again later.", function (res) {

                });
              })

              $q.when (beneficiaryModel.getList())
              .then (function (res) {
                console.log ('Received Beneficiaries List! (signInCtrl)');
              }, function (error) {
                console.log ('Error getting Beneficiaries (signInCtrl)');
                console.log(error);
              });

            } else {
              var errorMsg;
              if (typeof response.response !== "undefined" && typeof response.response.mappErrorResponse !== "undefined"){
                errorMsg = response.response['mappErrorResponse'];
              } else {
                errorMsg = "Failed to get response from Server.";
              }

              $scope.showAlert("Login Failed!", errorMsg, function (res) {
              });

            }
          });
      }, function (error) {
        console.log ("Error while fetching value of AppToken/MobileNo" + error);
        console.log (error);
        var errorMsg;
        /* dbService will return a string in case of error */
        if (angular.isString(error)) {
          errorMsg = error;
        } else {

          if (typeof error.response !== "undefined" && typeof error.response.mappErrorResponse !== "undefined"){
            errorMsg = error.response['mappErrorResponse'];
          } else {
            errorMsg = "Failed to get response from Server.";
          }
        }

        $scope.showAlert("Login Failed!", errorMsg, function (res) {
        });
        // User will have to clear app data and register again!
      });
    } else {
      ConnectivityMonitor.showNoConnectionAlert();
    }

  }
}])
srvtApp.service ('srvtHelper', ['$state', 'commonParameters', '$ionicPopup', '$http', '$ionicLoading', 'Auth', '$ionicHistory', '$q', 'accountsModel', '$cordovaKeyboard', '$timeout', '$ionicSideMenuDelegate', 'Idle', function ($state, commonParameters, $ionicPopup, $http, $ionicLoading, Auth, $ionicHistory, $q, accountsModel, $cordovaKeyboard, $timeout, $ionicSideMenuDelegate, Idle) {
	return {
		setRootScopeHooks : function(root) {

      root.mobileNoRegex = "^([7-9][0-9]{9})$";

		  root.show = function () {
	        $ionicLoading.show();
	      }

	      root.hide = function () {
	        if ($http.pendingRequests.length < 1) {
	          $ionicLoading.hide();
	        }
	      };

        root.hideKeyboard = function() {
          $cordovaKeyboard.close();
        }

        root.focusOn = function (name) {
          _root = this;
          $timeout(function () {
            _root.$broadcast('focusOn', name);
          });
        }

	      root.logout = function () {
	    	// TODO: Clear user data
	    	Auth.setLoggedIn(false);
	        /* Show signin screen */
            // $state.go('activation5', {}, {reload: true});
            Auth.showFirstScreen();
	      }

	      root.deregister = function () {
	    	// TODO: Clear user data
	    	$q.when (Auth.setIsRegistered(false))
	    	.then(function () {
	            Auth.showFirstScreen();
	    	}, function () {
	    		console.log ('Failed to clear registration flag!');
	    	})
	      }

	      root.showAlert = function (title, template, callback) {
            var alert = $ionicPopup.alert({
        		title: title,
            	template: template
            });
            alert.then(callback);

            root.$on('IdleTimeout', function () {
              if (angular.isDefined(alert))
                alert.close();
            });
          }

  	      root.showConfirmationAlert = function (title, template, assertiveBtnText, callback) {
            var confirm = $ionicPopup.confirm({
        		title: title,
        		cssClass: 'srvt-popup',
            	template: template,
            	buttons: [{ text: 'Cancel',
            			    type: 'button-stable',
            				onTap: function (e) {
            					return false;
            				} },
            			  { text: '<b>' + assertiveBtnText + '<b>', 
            			    type: 'button-assertive',
            				onTap: function (e) {
            					return true;
            				}}]
            });
            confirm.then(callback);

            root.$on('IdleTimeout', function () {
              if (angular.isDefined(confirm))
                confirm.close();
            });
          }

          root.getCommonParams = function () {
          	return commonParameters.get();
          }

          root.getTimeStamp = function () {

  	        function pad2(n) {  // always returns a string
            	return (n < 10 ? '0' : '') + n;
        	}

        	var date = new Date();
			return date.getFullYear() +
	               pad2(date.getMonth() + 1) + 
	               pad2(date.getDate()) +
	               pad2(date.getHours()) +
	               pad2(date.getMinutes()) +
	               pad2(date.getSeconds());        	
          }

          root.getSequenceNo = function () {
          	return Math.floor(Math.random()*900000) + 100000;
          }

          root.getAccounts = function () {
            var deferred = $q.defer();
	           $q.when(accountsModel.getAccounts())
      			.then(function (accounts) {
      			  root.accounts = accounts;
              deferred.resolve(accounts);
              return deferred.promise;
      			}, function (error){
              deferred.reject(error);
              return deferred.promise;
      			});
            return deferred.promise;
          }

          root.showHome = function () {
          	$ionicHistory.nextViewOptions({
    			  disableBack: true,
    			  historyRoot: true
    			});

          	$state.go('app.home', {}, {reload: true});
          }

          root.goToState = function (state) {
            /* Removed menu-close directive from side menu options (New Car, Card Upgrade, Block Request, Deregister)
               and hide the menu using sidemenu delegate to fix the above screens not showing Back button as
               For the above screens menu-close directive was triggering nextViewOptions with historyRoot as true */
            $state.go(state, {}, {reload: true});

            $ionicSideMenuDelegate.toggleLeft(false);
          }

          root.accounts = [];
		}
	}
}])
srvtApp.controller('statementRequestCtrl', ['$scope', '$ionicNavBarDelegate', 'restAPIService', 'ServerConfig', '$ionicHistory', function($scope, $ionicNavBarDelegate, restAPIService, ServerConfig, $ionicHistory) {

  $scope.data = {};
  var date = new Date();
  $scope.data.fromDate = angular.copy(date);
  $scope.data.fromDate.setDate(1);
  $scope.data.fromDate.setMonth(date.getMonth() - 1);

  $scope.data.toDate = angular.copy (date);
  $scope.data.toDate.setDate(1);
  $scope.data.toDate.setHours(-1);

  $scope.$on("$ionicView.beforeEnter", function() {
  /* Added here so that back button is visible even if the view is loaded from cache */
    $ionicNavBarDelegate.showBackButton(true);

    if ($scope.accounts.length == 0)
      $scope.getAccounts();
  });

  $scope.submit = function (form) {

    if (form.$invalid)
      return;

    $scope.hideKeyboard();

    var param = $scope.getCommonParams();
    param['subject'] = 'statement-request';

    var mode;

    if ($scope.data.softCopy && $scope.data.hardCopy)
    	mode = "SoftCopy + HardCopy";
    else if ($scope.data.softCopy)
    	mode = "SoftCopy";
    else if ($scope.data.hardCopy)
    	mode = "HardCopy";

    param['delivery-mode'] = $scope.data.softCopy ? "softCopy" : "hardCopy";
    param['period-from'] = $scope.data.fromDate;
    param['period-to'] = $scope.data.toDate;
    param['account-number'] = $scope.data.selectedAccount.accountNo;

    restAPIService.sendRequest(ServerConfig.APPLY_ONLINE, param)
    .then(function(response) {
      console.log ('Received response for applyNow');
      console.log (response);

      if (response.success == true) {
       	$scope.showAlert("Request Sent", "Your request for Statement is sent to the bank.", function () {
          $ionicHistory.goBack();
        });
      } else {
       	$scope.showAlert("Failed to Apply", response.response.mappErrorResponse, function (){
       	});
      }

    },
    function (error) {
      console.log ('Failed to ApplyNow:' + error);
    });

  }
}])
srvtApp.service ('updateService', ['$ionicDeploy', '$ionicPopup', function ($ionicDeploy, $ionicPopup) {

	this.checkForUpdate = function () {
      $ionicDeploy.check().then(function(snapshotAvailable) {
      // When snapshotAvailable is true, you can apply the snapshot
          if (snapshotAvailable) {

            var confirm = $ionicPopup.confirm({
            title: title,
            cssClass: 'srvt-popup',
              template: template,
              buttons: [{ text: 'Later',
                      type: 'button-stable',
                    onTap: function (e) {
                      return false;
                    } },
                    { text: '<b>' + 'Update Now' + '<b>', 
                      type: 'button-dark',
                    onTap: function (e) {
                      return true;
                    }}]
            });

            confirm.then(function (response) {
              if (response) {
                $ionicDeploy.download().then(function() {
                  $ionicDeploy.extract().then(function () {
                    // Restart with updated version
                    $ionicDeploy.load();
                  });
                });
              }
            });
          }
      });
  }
}])